;
; }CR1 2 3C^[tF[Xp 6
;	copyright(c) T.Nakao 2007
;
; I2Cn[hEFA}X^EAvP[V
;	EEPROMR/W

	LIST	 p=16f877a
	INCLUDE <p16F877a.inc>
	INCLUDE <..\\common\\ComDef.inc>
	INCLUDE <..\\common\\I2CHM.inc>
	INCLUDE <..\\common\\Hexa.inc>
	INCLUDE <..\\common\\Lcd.inc>
	INCLUDE <..\\common\\Key.inc>
	INCLUDE <..\\common\\Delay.inc>
	INCLUDE <..\\common\\AppFnc.inc>

	__CONFIG 0x3F72

	GLOBAL arg1, arg2

	radix	dec

	UDATA
arg1    RES 1
arg2    RES 1
RcvData RES 1
key		RES 1


RESET CODE 0
	GOTO START
	NOP
	NOP
	GOTO INTERRUPT

	CODE

START:

MAIN:
	BANKSEL	TRISC
	BCF		TRISC, 0		;LED1
	BCF		TRISC, 1		;LED2

	CALL	LCDInit

	;I2C
	CALL	I2CMsInit

 	;------------- I2C-EEPROM݃eXg --------------
	MOVLW	0
	CALL	I2CStart	;X^[gRfBV
	;
	MOVLW	0xA0		;CB(W)
	CALL	I2CWrite

	;
	MOVLW	0x01		;ROM Address(H)
	CALL	I2CWrite
	;
	MOVLW	0x23		;ROM Address(L)
	CALL	I2CWrite
	;
	MOVLW	0x75		;ROM Data
	CALL	I2CWrite
	;
	CALL	I2CStop	;XgbvRfBV

	CALL	Delay5ms	;EEPROM݊҂
	CALL	Delay5ms

	BANKSEL	RcvData	;UNAĂ
	LDLF	0, RcvData

	;------------- I2C-EEPROMǏoeXg --------------
	MOVLW	0
	CALL	I2CStart	;X^[gRfBV

	MOVLW	0xA0		;CB(W)
	CALL	I2CWrite
	;
	MOVLW	0x01		;ROM Address(H)
	CALL	I2CWrite
	;
	MOVLW	0x23		;ROM Address(L)
	CALL	I2CWrite
	;
	MOVLW	1			;repeat
	CALL	I2CStart	;s[gX^[gRfBV

	MOVLW	0xA1		;CB(R)
	CALL	I2CWrite
	;
	CLRW				;ACK
	CALL	I2CRead
	BANKSEL	RcvData
	MOVWF	RcvData		;Mf[^ۑ
	;
	CALL	I2CStop	;XgbvRfBV

 	;---------- LCD\eXg I2CǏof[^\ ----------
	BANKSEL	RcvData
	MOVF	RcvData, W			;I2CMf[^𕜋A
	CALL	LCDPrint2Hexa		;LCD֕\

	BANKSEL	CurX

	LDLF	1, CurY
	LDLF	6, CurX
	CALL	LCDGotoXY
	;
	BANKSEL	arg1
	MOVLW	0xCD
	MOVWF	arg1
	MOVLW	0xAB
	MOVWF	arg2
	CALL	LCDPrint4Hexa


	CALL	InitBtn

MainLoop:
	CALL	ScanBtn

	CALL	GetBtn
	IORLW	0
	BZ		next1			;͂ȂƂ
	MOVWF	key

	BANKSEL	PORTC
	MOVLW	1				;LED1(b0)
	XORWF	PORTC, F		;]

	BANKSEL	CurY
	LDLF	0, CurY
	LDLF	3, CurX
	CALL	LCDGotoXY

	MOVF	key, W
	CALL	LCDPrint2Hexa

	BANKSEL	CurY
	LDLF	0, CurY
	LDLF	6, CurX
	CALL	LCDGotoXY

	MOVLW	0
	CALL	GetSw
	CALL	LCDPrint2Hexa


	BANKSEL	BtnCode
	LDLF	0,  BtnCode
	GOTO	MainLoop

next1:
	MOVLW	4
	CALL	GetSw
	IORLW	0
	BZ		jj1
	BSF		PORTC, 1	;LED2 ON
	GOTO	MainLoop

jj1:
	BCF		PORTC, 1	;LED2 OFF
	GOTO	MainLoop


INTERRUPT:
;	LED2_ON
	RETFIE

	END
