;
; }CR1 2 3C^[tF[Xp 13
;	copyright(c) T.Nakao 2007
;
; One-Wire vWFNg4
;	1-Wirevg^CvEhCo
;

	LIST	 p=16f877a
	INCLUDE <p16F877a.inc>
	INCLUDE <..\\Common\\ComDef.inc>

	GLOBAL OneWireInit, OWBusReset, OWWriteByte, OWReadByte
	GLOBAL OWCrc, CrcBuf, CrcCnt

	radix	dec

bitDQ	EQU	3		;RC3
bitSPU	EQU	4		;RC4


	UDATA
; local
tmp0	RES 1
cnt		RES	1
iobyte	RES 1
i		RES 1
j		RES 1
ptr		RES 1

; global
CrcBuf	RES	9
CrcCnt	RES	1
CrcSr	RES	1


; DQ output "L" or "H"(Hi-Z pullup)
DQ MACRO dt
	IF dt == 1				;output pullup H
		BANKSEL	TRISC
		BSF TRISC, bitDQ	;input(Hi-Z)
		;
	ELSE					;output L
		BANKSEL PORTC
		BCF	PORTC, bitDQ	;reset DQ
		BANKSEL	TRISC
		BCF TRISC, bitDQ	;output
	ENDIF
	ENDM


; Strong Pullup
SPU	MACRO dt
	BANKSEL	PORTC
	IF dt == 1
		BSF	PORTC, bitSPU
	ELSE
		BCF	PORTC, bitSPU
	ENDIF
	ENDM



;*************************************************
; 5usPʂ̃fBC
;   PIC CLOCK = 20MHz
;   time̒Pʂus.ݒl5usPʂɕ␳
;*************************************************
WAIT5us	MACRO time
	MOVLW	time/5
	BANKSEL	tmp0
	MOVWF	tmp0
	CALL	w5us
	ENDM


	CODE

;*************************************************
; 5usPʂ̃fBCETu[`
;*************************************************
lp:
	NOP		;NOP x 5
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	;
w5us:
	NOP		;NOP x 15
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	DECFSZ	tmp0
	GOTO lp
	RETURN


;*************************************************
;  1-wire 
;*************************************************
OneWireInit:
	BANKSEL	PORTC
	BCF	PORTC,	bitSPU

	BANKSEL	TRISC
	BSF	TRISC,	bitDQ		;input(Hi-Z:H)
	BCF	TRISC,	bitSPU		;output
	RETURN


;*************************************************
;  oXEZbgs(v[XEpXo)
;    060910 sʂWWX^ɕύX
;    W: 1:v[XEpXo
;*************************************************
OWBusReset:
	DQ		0					;DQ="L"
	WAIT5us	500
	DQ		1					;DQ="H"(Hi-Z)
	WAIT5us	70
	BANKSEL PORTC
	BTFSS	PORTC, bitDQ		;input
	GOTO	j_br
	;
	WAIT5us	430
	RETLW	0					;񌟏o
j_br:
	WAIT5us	430
	RETLW	1					;oXZbgo



;*************************************************
;  1-wire 1oCgo
;    W:o̓f[^
;*************************************************
OWWriteByte:
	BANKSEL iobyte
	MOVWF	iobyte		;o̓f[^ W->iobyte
	MOVLW	8
	MOVWF	cnt
wlp:
	DQ	0				;DQ="L"
	WAIT5us	5			;wait 5us
	BANKSEL	iobyte
	RRF	iobyte, F
	BTFSC	STATUS, C
	GOTO	w1
w0:					;write "0" slot
	WAIT5us	60
	DQ	1			;DQ="H"(Hi-Z)
	NOP				;wait 2us
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	;
	BANKSEL	cnt
	DECFSZ	cnt, F
	GOTO wlp
	RETURN
	;
w1:					;write "1" slot
	DQ	1			;DQ="H"(Hi-Z)
	GOTO w0


;*************************************************
;  1-wire 1oCg
;    W:̓f[^
;*************************************************
OWReadByte:
	BANKSEL	cnt
	MOVLW	8
	MOVWF	cnt
rlp:
	DQ	0				;DQ="L"
	WAIT5us	5			;wait 5us
	DQ	1				;DQ="H"(Hi-Z)
	WAIT5us	5			;wait 5us
	;
	BANKSEL	PORTC
	BTFSC	PORTC,	bitDQ
	GOTO	r1
r0:						;DQ="L"
	BCF	STATUS,	C		;C=0
r12:
	BANKSEL	iobyte
	RRF		iobyte		;rotate right
	WAIT5us	50			;wait 50us
	DECFSZ	cnt, F
	GOTO	rlp;
	MOVFW	iobyte		;̓f[^->W
	RETURN
	;
r1:						;DQ="H"
	BSF	STATUS, C		;C=1
	GOTO	r12


;*************************************************
;  1-wire CRCvZ
;    CrcBuf[9]:팟f[^(8or9oCg)
;    CrcCnt:   vZΏۂ̃oCg 060905
;*************************************************
OWCrc:
	BANKSEL	CrcCnt
	MOVFW	CrcCnt		;vZΏۂ̃f[^
	MOVWF	i
	CLRF	CrcSr		;VtgWX^ NA
	MOVLW	CrcBuf		;AhX
	MOVWF	ptr			;obt@̐擪AhXݒ
	;
lp1:
	BANKSEL	j
	MOVLW	8
	MOVWF	j
	;
	MOVFW	ptr
	MOVWF	FSR
	MOVFW	INDF
	MOVWF	iobyte		;팟f[^1oCgo
	INCF	ptr, F		;̃f[^
	;
lp2:
	MOVFW	iobyte
	XORWF	CrcSr, W
	ANDLW	1
	BZ		j1
	;
	; 1̂Ƃ
	MOVLW	0x18
	XORWF	CrcSr, F
	;
	SETC
	RRF	CrcSr, F
	;
j2:
	RRF	iobyte, F
	DECFSZ	j
	GOTO	lp2
	;
	DECFSZ	i
	GOTO	lp1
	MOVFW	CrcSr
	RETURN
	;
j1:	; 0̂Ƃ
	CLRC
	RRF	CrcSr, F
	GOTO	j2


	END
