;
; 060603
;
; eXgpC[`(SPI MSSP쓮)
;

	LIST	 p=16f877a
	INCLUDE <p16F877a.inc>
	INCLUDE <..\\Common\\ComDef.inc>
	INCLUDE <..\\common\\Hexa.inc>
	INCLUDE <..\\common\\Lcd.inc>
	INCLUDE <..\\common\\Key.inc>
	INCLUDE <..\\common\\Delay.inc>
	INCLUDE <..\\Common\\SPIHMS.inc>

	__CONFIG 0x3F72

	GLOBAL arg1, arg2

	radix	dec

; SPI|[g
SCK	EQU 3		;RC3
SDI	EQU 4		;RC4
SDO	EQU 5		;RC5
SS	EQU 5		;RA5

SS_ON	MACRO
	BANKSEL	PORTA
	BCF		PORTA, SS		;SS enable
	ENDM

SS_OFF	MACRO
	BANKSEL	PORTA
	BSF		PORTA, SS		;SS disanable
	ENDM


	UDATA
arg1    RES 1
arg2    RES 1
key		RES 1

tmp1	RES	1
tmp2	RES 1


RESET CODE 0
	GOTO	START
	NOP
	NOP
	GOTO	INTERRUPT

	CODE

START:
;	CALL	copy_init_data

MAIN:
	BANKSEL	TRISC
	BCF		TRISC, 0			;LED1
	BCF		TRISC, 1			;LED2


	CALL	LCDInit			;LCD
	CALL	InitBtn			;{^

	CALL	SPIMsInit		;SPI

	BANKSEL	TRISA
	BCF		TRISA, SS		;RA5 SPI-SS output
	SS_OFF

	LED1_OFF
	LED2_OFF


MainLoop:
	CALL	ScanBtn			;{^̓XL
	;
	CALL	GetBtn
	IORLW	0
	BZ		next1			;͂ȂƂ
	BANKSEL	key
	MOVWF	key				;̓R[hۑ
	DECF	key
	BZ		j_btn1
	DECF	key
	BZ		j_btn2
	DECF	key
	BZ		j_btn3
	;
	; j_btn4					;Btn4̏ LCDNA
	CALL	LCDClear			;LCDNAs
	LED1_OFF
	LED2_OFF
	GOTO	next1

j_btn1:						;Btn1̏ SPI}X^M

	CALL	LCDClear			;LCDNAs

	SS_ON
	;
	MOVLW	0xA5
	CALL	SPIMsCom
	CALL	LCDPrint2Hexa		;LCD֎Mf[^(8rbg)\
	MOVLW	0xF0
	CALL	SPIMsCom
	CALL	LCDPrint2Hexa		;LCD֑Mf[^(8rbg)\
	;
	SS_OFF

	GOTO	next1

j_btn2:						;Btn2̏

	CALL	LCDClear			;LCDNAs

	SS_ON
	;
	MOVLW	0x69
	CALL	SPIMsCom
	CALL	LCDPrint2Hexa		;LCD֎Mf[^(8rbg)\
	MOVLW	0x23
	CALL	SPIMsCom
	CALL	LCDPrint2Hexa		;LCD֑Mf[^(8rbg)\
	;
	SS_OFF
	GOTO	next1

j_btn3:						;Btn3̏
	GOTO	next1

next1:
	GOTO	MainLoop



INTERRUPT:
	RETFIE


	END
