;
; }CR1 2 3C^[tF[Xp
;	copyright(c) T.Nakao 2007
;
; I2Cn[hEFA}X^EhCo
;

	LIST	 p=16f877a
	INCLUDE	<p16F877a.inc>
	INCLUDE	<..\\common\\ComDef.inc>

	EXTERN	arg1, arg2
	GLOBAL	I2CMsInit, I2CStart, I2CStop, I2CRead, I2CWrite
	GLOBAL	I2C_TxData, I2C_RxData

	radix	dec

; [Jϐ
	UDATA
tmp1	RES 1

	CODE

;****************************************
; I2C(MSSPgp)
;****************************************
I2CMsInit:
	BANKSEL	SSPCON
	BSF		SSPCON, SSPM3		;SSPM3-0:1000
	BCF		SSPCON, SSPM2
	BCF		SSPCON, SSPM1
	BCF		SSPCON, SSPM0

	BANKSEL	SSPSTAT
;	BCF		SSPSTAT, SMP		;X[[g400MHz
	BSF		SSPSTAT, SMP		;X[[g100MHz
	BCF		SSPSTAT, CKE

;	LDLF	0x19, SSPADD		;{[[g
	LDLF	0x3F, SSPADD		;{[[g

	BANKSEL	SSPCON
	BSF		SSPCON, SSPEN		;MSSP enable(ŌɎs邱)

	BANKSEL SSPCON
	BCF		SSPCON, WCOL
	BCF		SSPCON, SSPOV

	RETURN


;****************************************
; I2CX^[gRfBV
;    IN W: 0:NORM/1:REPEAT
;****************************************
I2CStart:
	BANKSEL	SSPCON2
	IORLW	0
	BZ		jj01
	; Repeat start condition
	BSF		SSPCON2, RSEN
	GOTO jj02

jj01:
	; Normal start condition
	BSF		SSPCON2, SEN

jj02:
	WAIT_SSPIF					;X^[gRfBV҂
	CLR_SSPIF

	RETURN


;****************************************
; I2CXgbvRfBV
;****************************************
I2CStop:
	BANKSEL	SSPCON2
	BSF		SSPCON2, PEN
	WAIT_SSPIF					;XgbvRfBV҂
	CLR_SSPIF

	RETURN


;****************************************
; I2C 1oCgf[^,ACKo(MSSP)
;   IN  W: ACK(1:NOACK/0:ACK)
;   OUT W: ̓f[^
;****************************************
I2CRead:
	BANKSEL	SSPCON2
	IORLW	0
	BZ		j_ack				;W==0(ACK)
	;NOACK
	BSF		SSPCON2, ACKDT		;ACK=1
	GOTO	j_next
j_ack:
	;ACK
	BCF		SSPCON2, ACKDT		;ACK=0
	;
j_next:
	BSF		SSPCON2, RCEN		;M
	WAIT_SSPIF					;M҂
	MOVFW 	SSPBUF				;Mf[^o
	BANKSEL	tmp1
	MOVWF	tmp1
	CLR_SSPIF

	BANKSEL	SSPCON2
	BSF		SSPCON2, ACKEN		;ACKM
	WAIT_SSPIF					;ACKM҂

	CLR_SSPIF
	BANKSEL	tmp1
	MOVFW	tmp1				;WMf[^
	RETURN


;****************************************
; I2C 1oCgf[^o,ACK(MSSP)
;   IN  W: o̓f[^
;   OUT W: 0:ACK/1:NOACK
;****************************************
I2CWrite:
	BANKSEL SSPSTAT
	BTFSC SSPSTAT, BF			;BUSY`FbN
	GOTO $ - 1					;BFNA܂ő҂

	LED1_ON

	BANKSEL SSPBUF
	MOVWF	SSPBUF				;MJn


	CLR_SSPIF


	WAIT_SSPIF					;M҂
;	LED2_ON

	; SSPCON2.ACKSTATACKԂĂ

	BANKSEL SSPCON2
	BTFSC SSPCON2, ACKSTAT
	GOTO NACK
	; ACK
	CLR_SSPIF
	CLRW						;0(ACK)Ń^[
	RETURN

NACK:
	CLR_SSPIF
	MOVLW 1						;1(NOACK)Ń^[
	RETURN


;****************************************
; I2Cf[^M
;	IN arg1: I2CX[uAhX
;	   arg2: Mf[^
;****************************************
I2C_TxData:
	CLRW
	CALL	I2CStart			;X^[gRfBV
	;
	RLF		arg1, F				;I2CX[uAhX
	BCF		arg1, 0				;W
	MOVFW	arg1				;Rg[oCg
	CALL	I2CWrite
	;	ACK`FbN͏ȗ
	MOVFW	arg2				;Mf[^
	CALL	I2CWrite
	;	ACK`FbN͏ȗ
	CALL	I2CStop				;XgbvRfBV
	;
	RETURN


;****************************************
; I2Cf[^M
;	IN  arg1: I2CX[uAhX
;	OUT w: Mf[^
;****************************************
I2C_RxData:
	CLRW
	CALL	I2CStart			;X^[gRfBV
	;
	RLF		arg1, F				;I2CX[uAhX
	BSF		arg1, 0				;R
	MOVFW	arg1				;Rg[oCg
	CALL	I2CWrite
	;	ACK`FbN͏ȗ
	CALL 	I2CRead				;WMf[^
	;
	CALL	I2CStop				;XgbvRfBV
	;
	RETURN


	END
