;
; }CR1 2 3C^[tF[Xp
;	copyright(c) T.Nakao 2007
;
; I2C\tgEFA}X^EhCo
;

	LIST	 p=16f877a
	INCLUDE	<p16F877a.inc>
	INCLUDE	<..\\common\\ComDef.inc>
	INCLUDE	<..\\common\\Delay.inc>

	EXTERN	arg1, arg2
	GLOBAL	I2CMsInit, I2CStart, I2CStop, I2CRead, I2CWrite
	GLOBAL	I2C_TxData, I2C_RxData

	radix	dec

bitSDA	EQU 4
bitSCL	EQU 3

; [Jϐ
	UDATA
tmp1	RES 1
lpc1	RES 1		;loop counter
BData	RES 1		;receive data buffer

;
; }N`
;
SDA MACRO dt
	IF dt == 1
		BSF	PORTC, bitSDA
	ELSE
		BCF	PORTC, bitSDA
	ENDIF
	ENDM

SCL MACRO dt
	IF dt == 1
		BSF	PORTC, bitSCL
	ELSE
		BCF	PORTC, bitSCL
	ENDIF
	NOP						;200nsX2
	NOP
	ENDM


SDA_INPUT MACRO
	BANKSEL	TRISC
	BSF		TRISC, bitSDA	;input
	ENDM

SDA_OUTPUT MACRO
	BANKSEL	TRISC
	BCF		TRISC, bitSDA	;output
	ENDM


	CODE

;****************************************
; I2C(\tgEFA쓮)
;****************************************
I2CMsInit:
	BANKSEL	TRISC
	BCF		TRISC, bitSDA		;SDA output
	BCF		TRISC, bitSCL		;SCL output

	BANKSEL PORTC
	BSF		PORTC, bitSDA		;SDA=H
	BSF		PORTC, bitSCL		;SCL=H
	;
	RETURN


;****************************************
; I2X^[gRfBV(\tgEFA쓮)
;     W 0:NORM/1:REPEAT
;****************************************
I2CStart:

	IORLW	0
	BTFSC	STATUS, Z
	GOTO	jj05
	; Repeat start condition
	BANKSEL	PORTC
	SDA		1
	WAIT5us	10
	BANKSEL	PORTC
	SCL		1
	WAIT5us	10
	;
jj05:
	BANKSEL	PORTC
	SDA		0
	WAIT5us	10
	BANKSEL	PORTC
	SCL		0
	WAIT5us	10
	RETURN


;****************************************
; I2CXgbvRfBV(\tgEFA쓮)
;****************************************
I2CStop:
	BANKSEL	PORTC
	SCL		1
	WAIT5us	10
	BANKSEL	PORTC
	SDA		1
	WAIT5us	10
	RETURN


;****************************************
; I2C 1oCgf[^,ACKo(\tgEFA쓮)
;    W ACK(1:NOACK/0:ACK)
;   ߒl W ̓f[^
;****************************************
I2CRead:
	BANKSEL	tmp1
	MOVWF	tmp1

	BANKSEL	lpc1
	MOVLW	8
	MOVWF	lpc1		;[v񐔂ݒ
	;

	SDA_INPUT			;SDA͂ɐݒ

lp02:
	; SDA1rbg
	BANKSEL	PORTC
	SCL		1
	WAIT5us	10
	BANKSEL	PORTC
	;
	BTFSS PORTC, bitSDA
	GOTO j01
	; SDA=1
	BSF		STATUS, C		;set Carry flag
	GOTO	j02
j01:
	; SDA=0
	BCF		STATUS, C		;reset Carry flag
j02:
	BANKSEL	BData
	RLF		BData			;set 1bit data
	BANKSEL	PORTC
	SCL		0
	WAIT5us	10
	BANKSEL	lpc1
	DECFSZ	lpc1
	GOTO	lp02

	;ACKM
	BANKSEL	PORTC
	SDA		0
	SDA_OUTPUT				;o͂ɐؑ

	WAIT5us	10

	;ACKo
	BANKSEL	tmp1
	MOVFW	tmp1
	IORLW	0
	BNZ		j03
	;0:ACK
	BANKSEL	PORTC
	SDA		0				;ACK
	GOTO	j04
j03:
	;1:NOACK
	BANKSEL	PORTC
	SDA		1				;NOACK
j04:
	WAIT5us	10
	BANKSEL	PORTC
	SCL		1
	WAIT5us	10
	BANKSEL	PORTC
	SCL		0
	WAIT5us	10
	BANKSEL	PORTC
	SDA		0
	WAIT5us	10

	BANKSEL	BData
	MOVF	BData, W

	RETURN


;****************************************
; I2C 1oCgf[^o,ACK(\tgEFA쓮)
;    W o̓f[^
;   ߒl W 0:ACK/1:NOACK
;****************************************
I2CWrite:
	BANKSEL	tmp1
	MOVWF	tmp1
	BANKSEL	lpc1
	MOVLW	8
	MOVWF	lpc1
	;
lp01:
	; SDA1rbgo
	BANKSEL	tmp1
	RLF		tmp1, F		;test bit7 and shift
	BTFSC	STATUS, 0		;carry
	GOTO	label01
	;bit==0
	BANKSEL	PORTC
	SDA		0
	GOTO	label02
label01:
	;bit==1
	BANKSEL	PORTC
	SDA		1
label02
	WAIT5us	10
	BANKSEL	PORTC
	SCL		1
	WAIT5us	10
	BANKSEL	PORTC
	SCL		0
	;
	BANKSEL	lpc1
	DECFSZ	lpc1
	GOTO	lp01

	;ACKM
	BANKSEL	PORTC
	SDA		0
	SDA_INPUT				;͂ɐؑ
	BANKSEL	PORTC
	WAIT5us	10
	BANKSEL	PORTC
	SCL		1
	;
	BTFSS	PORTC, bitSDA
	GOTO	label03

	WAIT5us	10
	BANKSEL	PORTC
	SCL		0
	WAIT5us	10
	BANKSEL	PORTC
	SDA_OUTPUT
	WAIT5us	10
	RETLW	1
	;
label03:
	WAIT5us	10
	BANKSEL	PORTC
	SCL		0
	WAIT5us	10
	BANKSEL	PORTC
	SDA_OUTPUT
	WAIT5us	10
	RETLW	0





;****************************************
; I2Cf[^M
;	arg1: I2CX[uAhX
;	arg2: Mf[^
;****************************************
I2C_TxData
	CLRW
	CALL	I2CStart			;X^[gRfBV
	;
	RLF		arg1, F				;I2CX[uAhX
	BCF		arg1, 0				;W
	MOVFW	arg1				;Rg[oCg
	CALL	I2CWrite
	;	ACK`FbN͏ȗ
	MOVFW	arg2				;Mf[^
	CALL	I2CWrite
	;	ACK`FbN͏ȗ
	CALL	I2CStop			;XgbvRfBV
	;
	RETURN


;****************************************
; I2Cf[^M
;	arg1: I2CX[uAhX
;	w: Mf[^
;****************************************
I2C_RxData:
	CLRW
	CALL	I2CStart			;X^[gRfBV
	;
	RLF		arg1, F				;I2CX[uAhX
	BSF		arg1, 0				;R
	MOVFW	arg1				;Rg[oCg
	CALL	I2CWrite
	;	ACK`FbN͏ȗ
	CALL 	I2CRead				;WMf[^
	;
	CALL	I2CStop				;XgbvRfBV
	;
	RETURN


	END
