;
; }CR1 2 3C^[tF[Xp
;	copyright(c) T.Nakao 2007
;
; LCDhCo [`
;

; \[X
; LCD D4`D7: RD4`RD7
; LCD E:      RD1
; LCD RW:     RD2
; LCD RS:     RD3
;

	LIST	 p=16f877a
	INCLUDE	<p16F877a.inc>
	INCLUDE	<ComDef.inc>
	INCLUDE	<Delay.inc>

	GLOBAL	LCDInit, LCDWrite4Bit, LCDWriteData, LCDWaitReady
	GLOBAL	LCDGotoXY, LCDString
	GLOBAL	CurX, CurY, LCDClear, LCDPutc

	radix	dec

; LCD bit assignment

LCD_CTRL_PORT	EQU PORTD
LCD_DATA_PORT	EQU PORTD
BIT_E			EQU 1
BIT_RW			EQU 2
BIT_RS			EQU 3


LCD_RS MACRO FLG
	IF FLG == 1
		BSF LCD_CTRL_PORT, BIT_RS
	ELSE
		BCF LCD_CTRL_PORT, BIT_RS
	ENDIF
	ENDM

LCD_E MACRO FLG
	IF FLG == 1
		BSF LCD_CTRL_PORT, BIT_E
		NOP
		NOP
		NOP
		NOP
	ELSE
		BCF LCD_CTRL_PORT, BIT_E
	ENDIF
	ENDM

LCD_RW MACRO FLG
	IF FLG == 1
		BSF LCD_CTRL_PORT, BIT_RW
	ELSE
		BCF LCD_CTRL_PORT, BIT_RW
	ENDIF
	ENDM


	UDATA
; [Jϐ
temp1	RES 1
temp2	RES 1
temp3	RES 1
lopc	RES 1

;O[oϐ
CurX	RES 1
CurY	RES 1
arg1	RES 1
arg2	RES 1


;	IDATA
;LCD_INIT DB 0x28, 0x0C, 0x01, 0x06
;
LCD_INIT RES 4

	CODE

;***********************************************
; LCD
;***********************************************
LCDInit:

	; LCDf[^e[u̐ݒ()
	BANKSEL	LCD_INIT
	BANKISEL	LCD_INIT	;060909
	MOVLW	LCD_INIT
	MOVWF	FSR

	LDLF	0x28, INDF
	INCF	FSR, F
	LDLF	0x0C, INDF
	INCF	FSR, F
	LDLF	0x01, INDF
	INCF	FSR, F
	LDLF	0x06, INDF

	BANKSEL	PORTD
	CLRF	PORTD

	BANKSEL	TRISD
	MOVLW	0x0F			;RD3-RD7 output
	ANDWF	TRISD, F

	BCF	TRISD, BIT_RS		;output
	BCF	TRISD, BIT_E		;output
	BCF	TRISD, BIT_RW		;output

	CALL	Delay5ms
	CALL	Delay5ms
	CALL	Delay5ms

	BANKSEL	lopc
	LDLF	3, lopc

	BANKSEL	LCD_CTRL_PORT
	LCD_RS	0					;Registor
	LCD_RW	0					;Write

	CALL	Delay5ms

lp2:
	MOVLW	0x03
	CALL	LCDWrite4Bit

	BANKSEL	LCD_CTRL_PORT

	CALL	Delay5ms

	BANKSEL	lopc
	DECFSZ	lopc
	GOTO	lp2

	MOVLW	0x02
	CALL	LCDWrite4Bit

	BANKSEL	LCD_CTRL_PORT

	CALL	Delay5ms

	BANKSEL	lopc
	LDLF	4, lopc

	BANKSEL	LCD_INIT
	MOVLW	LCD_INIT
	MOVWF	FSR				;f[^̃|C^ݒ


lp3:
	CLRW					;registor select
	BANKSEL	arg1
	BANKISEL	arg1		;060909
	MOVWF	arg1
	MOVF	INDF, W
	CALL	LCDWriteData
	INCF	FSR, F			;next

	BANKSEL	lopc
	DECFSZ	lopc
	GOTO	lp3

	RETURN


;***********************************************
; 4rbg
;    W
;***********************************************
LCDWrite4Bit:

	BANKSEL	temp3
	MOVWF	temp3
	SWAPF	temp3, W		;4rbg4rbgֈړ(ւ)
	ANDLW	0xF0			;4rbgo
	MOVWF	temp3

	MOVLW	0x0F				;
	BANKSEL	LCD_DATA_PORT
	ANDWF	LCD_DATA_PORT, F	;LCDf[^o͂̏4rbgUNA

	BANKSEL	temp3
	MOVF	temp3, W
	BANKSEL	LCD_DATA_PORT
	IORWF	LCD_DATA_PORT, F	;LCD֏4rbgf[^o

	BANKSEL	LCD_CTRL_PORT
	LCD_E	1					;E Pulse
	LCD_E	0

	RETURN


;***********************************************
; LCD 1o
;    W:o͕
;***********************************************
LCDPutc:
	BANKSEL	temp1
	MOVWF	temp1				;o͕ꎞۑ
	LDLF	1, arg1
	MOVF	temp1, W			;o͕𕜋A
	;
	; LCDWriteDataɑ
	;
;***********************************************
; LCDf[^/WX^
;	 W:   o̓f[^
;	     arg1:o͐ 1:f[^/0:WX^
;***********************************************
LCDWriteData:
	BANKSEL	temp1		;o̓f[^ۑ
	MOVWF	temp1
	ANDLW	0x0F
	MOVWF	temp2		;b3-b0
	SWAPF	temp1, W	;4rbg4rbgֈړ(ւ)
	ANDLW	0x0F		;4rbgo
	MOVWF	temp1		;b7-b4

	CALL	LCDWaitReady				;BUSY check

	BANKSEL	arg1
	MOVFW	arg1
	IORLW	0
	BNZ		J1							;0łȂƂ
	; arg1==0 WX^
	BANKSEL	LCD_CTRL_PORT
	LCD_RS	0							;RS=0
	GOTO	J2
J1:
	; arg1!=0 f[^
	BANKSEL	LCD_CTRL_PORT
	LCD_RS	1							;RS=1
J2:
	LCD_RW	0							;Write

	BANKSEL	temp1
	MOVF	temp1, W					;o̓f[^𕜋A
	CALL	LCDWrite4Bit				;LCD D7-D4

	BANKSEL	temp2
	MOVF	temp2, W
	CALL	LCDWrite4Bit				;LCD D3-D0

	RETURN


;***********************************************
; LCD busy`FbN
;***********************************************
LCDWaitReady:
	BANKSEL	LCD_CTRL_PORT
	LCD_RS	0					;
	LCD_RW	1					;Read

	;RB7-RB4 input
	BANKSEL	TRISD
	MOVLW	0xF0
	IORWF	TRISD, F

bw:
	BANKSEL	LCD_CTRL_PORT
	LCD_E	1
	MOVF	LCD_DATA_PORT, W	;read upper
	BANKSEL	temp3
	MOVWF	temp3
	BANKSEL	LCD_CTRL_PORT
	LCD_E	0

	NOP
	LCD_E	1					;read lower(dummy)
	LCD_E	0

	BANKSEL	temp3
	BTFSC	temp3, 7			;TEST BF
	GOTO	bw

	BANKSEL	LCD_CTRL_PORT
	LCD_RW	0					;Write

	;RB7-RB4 output
	BANKSEL	TRISD
	MOVLW	0x0F
	ANDWF	TRISD, F

	RETURN


;***********************************************
; J[\ړ
;    CurX, CurY (0-org)
;***********************************************
LCDGotoXY:
	BANKSEL	CurY
	MOVFW	CurY
	IORLW	0
	BZ		J3				;CurY==0
	;
	;CurY!=0
	MOVLW	0x40			;line2
	ADDWF	CurX, F
J3:
	;CurY==0
	CLRF	arg1			;LCD WX^ZNg
	MOVF	CurX, W
	ADDLW	0x80			;LCD address set command
	GOTO	LCDWriteData


;***********************************************
; \(NULLI[)
;   FSR: obt@̐擪AhX
;***********************************************
LCDString:
	BANKSEL	arg1
	BANKISEL	arg1		;060909
	LDLF	1, arg1

jj11:
	MOVF	INDF, W			;o
	IORLW	0
	BZ		jj10			;NULL̂ƂI

	CALL	LCDWriteData
	INCF	FSR				;̕
	GOTO	jj11

jj10:
	RETURN


;***********************************************
; LCD\NA
;***********************************************
LCDClear:
	BANKSEL	arg1
	CLRF	arg1			;WX^ZNg
	MOVLW	0x01			;LCD clear command
	GOTO	LCDWriteData


	END
