;
; }CR1 2 3C^[tF[Xp
;	copyright(c) T.Nakao 2007
;
; 1-Wire\tgEFA}X^EhCo
;
;

	LIST	 p=16f877a
	INCLUDE <p16F877a.inc>
	INCLUDE <..\\Common\\ComDef.inc>
	INCLUDE <..\\Common\\Delay.inc>			;link Delay.asm
	INCLUDE <..\\Common\\OWDef.inc>

	GLOBAL	OWInit, OWBusReset, OWWriteByte, OWReadByte
	GLOBAL	OWCrc, CrcBufPtr, CrcCnt
	GLOBAL	OWRomSearch, OWGetRomBit, OWSetRomBit, OWClearRom
	GLOBAL	OWRead1Slot, OWWrite1Slot, OWReSearch
	GLOBAL	RomCode, OWDviceCnt

	EXTERN arg1

	radix	dec



	UDATA
; local
tmp0	RES 1
tmp1	RES 1
tmp2	RES 1
cnt		RES	1
iobyte	RES 1
i		RES 1
j		RES 1
ptr		RES 1
LastB	RES	1
ZeroB	RES	1
n		RES	1

; global
CrcBufPtr	RES	1
CrcCnt	RES	1
CrcSr	RES	1
RomCode	RES 8			;ROMR[hobt@
OWDviceCnt	RES 1		;ofoCX



	CODE


;*************************************************
;  1-wire 
;*************************************************
OWInit:
	BANKSEL	PORTC
	BCF		PORTC,	bitSPU

	BANKSEL	TRISC
	BSF		TRISC,	bitDQ		;input(Hi-Z:H)
	BCF		TRISC,	bitSPU		;output
	RETURN


;*************************************************
;  oXEZbgs(v[XEpXo)
;    060910 sʂWWX^ɕύX
;    OUT W: 1:v[XEpXo
;*************************************************
OWBusReset:
	DQ		0					;DQ="L"
	WAIT5us	500
	DQ		1					;DQ="H"(Hi-Z)
	WAIT5us	70
	BANKSEL PORTC
	BTFSS	PORTC, bitDQ		;input
	GOTO	j_br
	;
	WAIT5us	430
	RETLW	0					;񌟏o
j_br:
	WAIT5us	430
	RETLW	1					;oXZbgo


;*************************************************
;  1-wire 1oCgo
;    IN W:o̓f[^
;*************************************************
OWWriteByte:
	BANKSEL iobyte
	MOVWF	iobyte		;o̓f[^ W->iobyte
	MOVLW	8
	MOVWF	cnt
wlp:
	DQ	0				;DQ="L"
	WAIT5us	5			;wait 5us
	BANKSEL	iobyte
	RRF		iobyte, F
	BC		w1
w0:					;write "0" slot
	WAIT5us	60
	DQ		1		;DQ="H"(Hi-Z)
	NOP				;wait 2us
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	;
	BANKSEL	cnt
	DECFSZ	cnt, F
	GOTO	wlp
	RETURN
	;
w1:					;write "1" slot
	DQ		1		;DQ="H"(Hi-Z)
	GOTO	w0


;*************************************************
;  1-wire 1oCg
;    OUT W:̓f[^
;*************************************************
OWReadByte:
	BANKSEL	cnt
	MOVLW	8
	MOVWF	cnt
rlp:
	DQ	0				;DQ="L"
	WAIT5us	5			;wait 5us
	DQ	1				;DQ="H"(Hi-Z)
	WAIT5us	5			;wait 5us
	;
	BANKSEL	PORTC
	BTFSC	PORTC,	bitDQ
	GOTO	r1
r0:						;DQ="L"
	CLRC				;C=0
r12:
	BANKSEL	iobyte
	RRF		iobyte		;rotate right
	WAIT5us	50			;wait 50us
	DECFSZ	cnt, F
	GOTO	rlp;
	MOVFW	iobyte		;̓f[^->W
	RETURN
	;
r1:						;DQ="H"
	SETC				;C=1
	GOTO	r12


;*************************************************
;  1-wire CRCvZ
;    vZΏۂ̗̈̐擪AhXn悤ɕύX
;
;    IN
;      CrcCnt:    vZΏۂ̃oCg(8or9)
;      CrcBufPtr: vZΏۂ̗̈̐擪AhX
;    OUT
;      W: vZ(0̂Ƃ)
;*************************************************
OWCrc:
	BANKSEL	CrcCnt
	MOVFW	CrcCnt		;vZΏۂ̃f[^
	MOVWF	i
	CLRF	CrcSr		;VtgWX^ NA
	MOVFW	CrcBufPtr	;
	MOVWF	ptr			;obt@̐擪AhXݒ
	;
lp1:
	BANKSEL	j
	MOVLW	8
	MOVWF	j
	;
	BANKISEL	ptr
	MOVFW	ptr
	MOVWF	FSR
	MOVFW	INDF
	MOVWF	iobyte		;팟f[^1oCgo
	INCF	ptr, F		;̃f[^
	;
lp2:
	MOVFW	iobyte
	XORWF	CrcSr, W
	ANDLW	1
	BZ		j1
	;
	; 1̂Ƃ
	MOVLW	0x18
	XORWF	CrcSr, F
	;
	SETC
	RRF		CrcSr, F
	;
j2:
	RRF		iobyte, F
	DECFSZ	j, F
	GOTO	lp2
	;
	DECFSZ	i, F
	GOTO	lp1
	MOVFW	CrcSr
	RETURN
	;
j1:	; 0̂Ƃ
	CLRC
	RRF		CrcSr, F
	GOTO	j2


;*************************************************
; ROMR[h
;   OUT
;    0:s / 1:(cȂ) / 2:(c)
;*************************************************
OWRomSearch:
	BANKSEL	OWDviceCnt
	CLRF	OWDviceCnt		;ofoCX
	CLRF	LastB
	CALL	OWClearRom		;ROMR[hobt@ NA
	;
	;-------------------------------------
	; ROMp(2߈ȍ~̌)
	;-------------------------------------
OWReSearch:					;ČpGg
	BANKSEL	n
	LDLF	1, n
	CLRF	ZeroB
	;
	;-------------------------------------
	; oXEZbg
	;-------------------------------------
	CALL	OWBusReset
	IORLW	0
	BNZ		nx1
	RETLW	0					;v[XpX񌟏o return false
	;
nx1:
	;-------------------------------------
	; T[`ROM R}h
	;-------------------------------------
	MOVLW	0xF0			;SEARCH ROM command
	CALL	OWWriteByte		;R}hM
	;
	;-------------------------------------
	; bnǂݍ
	;-------------------------------------
lps1:
	CALL	OWRead1Slot		;bnǂݍ
	IORLW	0
	BNZ		jj1				;(bn,/bn)=(1,0) (m)
	; bn==0
	;-------------------------------------
	; /bnǂݍ
	;-------------------------------------
	CALL	OWRead1Slot		;/bnǂݍ
	IORLW	0
	BNZ		j_out0			;(bn,/bn)=(0,1)
	;
	;
	; bn==0, /bn==0(sv_)
	;
	BANKSEL	LastB
	MOVFW	LastB
	SUBWF	n, W
	BZ		j_out1			;"1"pX
	BC		j_out0s			;"0"pX
	;
	; n<LastB
	; OɌoꂽfoCXROMR[hnrbgƓl
	;
	MOVFW	n
	CALL	OWGetRomBit
	;
	IORLW	0
	BZ		j_out0s			; "0"pX
	GOTO	j_out1			; "1"pX
	;
	;
	; bn==1(or n==LastB)
	;-------------------------------------
	; /bn(␔rbg)ǂݍ
	;-------------------------------------
jj1:
	CALL	OWRead1Slot		;/bnǂݍ
	IORLW	0
	BNZ		j_err
	;
	; bn==1, /bn==0("1"pX)
	;---------------------------
	; "1"XbgM
	;---------------------------
j_out1:
	MOVLW	1
	CALL	OWWrite1Slot	;"1"Xbgo
	;
	;------------------------------
	; ROMR[hobt@̍XV bn=1
	;------------------------------
	BANKSEL	arg1
	MOVLW	1				;rbgl(1)
	MOVWF	arg1
	MOVFW	n
	CALL	OWSetRomBit
	GOTO	nx2
	;
	;
j_out0s:					;n>LastB
	BANKSEL	n
	MOVFW	n
	MOVWF	ZeroB			;ZeroB = n
	;
	; bn==0, /bn==1(or n>LastB)
	;---------------------------
	; "0"XbgM
	;---------------------------
j_out0:
	CLRW
	CALL	OWWrite1Slot	;"0"Xbgo
	;
	;------------------------------
	; ROMR[hobt@̍XV bn=0
	;------------------------------
	BANKSEL	arg1
	CLRW					;rbgl(0)
	MOVWF	arg1
	MOVFW	n
	CALL	OWSetRomBit
	;
	GOTO	nx2
	;
j_err:
	; bn==1, /bn==1(ُ)
	RETLW	0				;return false
	;
	;------------------------------
	; I`FbN
	;------------------------------
nx2:
	BANKSEL	n
	INCF	n, F
	MOVFW	n
	SUBLW	64		;L-W  64-n
	BC		lps1	;̃rbǧ
	;
	; 64rbgROMR[ho
	;
	MOVFW	ZeroB
	MOVWF	LastB				;LastB=ZeroB
	INCF	OWDviceCnt, F		;ofoCX
	;
	IORLW	0		;̗L𒲂ׂ
	BNZ		nx3		;õfoCX
	;
	RETLW	1		;true(1:I cȂ)
	;
nx3:
	RETLW	2		;true(2:I c肠)


;*************************************************
; ROMR[hEobt@ _rbgl擾
;   IN  W:rbgԍ(1`64)
;   OUT W:rbgl
;*************************************************
OWGetRomBit:
	BANKSEL	tmp0
	MOVWF	tmp0
	DECF	tmp0, W			;rbgԍ0`63ɊZ
	MOVWF	tmp0			;ROMR[hGÃoCgʒu
	MOVWF	tmp1			;ROMR[hʃoCg̃rbgʒu
	; 8Ŋ
	CLRC
	RRF		tmp0, F			;2
	CLRC
	RRF		tmp0, F			;2
	CLRC
	RRF		tmp0, F			;2
	;						;ROMoCgʒu(܂؂̂Ă̏)
	;
	MOVLW	0x07
	ANDWF	tmp1, F			;1oCg̃rbgʒu(8Ŋ̂܂)
	INCF	tmp1, F			;+1
	;
	CLRF	tmp2
	SETC					;set Carry flag
lp3:
	RLF		tmp2
	CLRC
	DECFSZ	tmp1, F			;܂+1̉񐔃[v
	GOTO	lp3
	;						;tmp2Ƀrbgp^[
	;
	BANKISEL	RomCode
	MOVLW	RomCode			;ROMR[hAhX
	ADDWF	tmp0, W			;Ώۂ̃oCgf[^̃AhX
	MOVWF	FSR
	MOVFW	INDF			;YoCg̒lǂݏo
	ANDWF	tmp2			;rbgp^[ANDƂ
	BZ		j3
	RETLW	1				;W=1Ń^[
	;
j3:
	RETLW	0				;W=0Ń^[


;*************************************************
; ROMR[hEobt@ _rbglݒ
;   IN W:rbgԍ(1`64)
;      arg1:ݒl(0/1)
;*************************************************
OWSetRomBit:
	BANKSEL	tmp0
	MOVWF	tmp0
	DECF	tmp0, W			;rbgԍ0`63ɊZ
	MOVWF	tmp0			;ROMR[hGÃoCgʒu
	MOVWF	tmp1			;ROMR[hʃoCg̃rbgʒu
	; 8Ŋ
	CLRC
	RRF		tmp0, F			;2
	CLRC
	RRF		tmp0, F			;2
	CLRC
	RRF		tmp0, F			;2
	;						;ROMoCgʒu(܂؂̂Ă̏)
	;
	MOVLW	0x07
	ANDWF	tmp1, F			;1oCg̃rbgʒu(8Ŋ̂܂)
	INCF	tmp1, F			;+1
	;
	CLRF	tmp2
	SETC					;set Carry flag
lp4:
	RLF		tmp2
	CLRC
	DECFSZ	tmp1, F			;܂+1̉񐔃[v
	GOTO	lp4
	;						;tmp2Ƀrbgp^[
	;
	MOVFW	tmp2
	MOVWF	tmp1			;rbgp^[tmp1ɃRs[
	COMF	tmp1, F			;tmp1Ƀrbgp^[̕␔(rbg])
	;
	BANKISEL	RomCode
	MOVLW	RomCode			;ROMR[hAhX
	ADDWF	tmp0, W			;Ώۂ̃oCgf[^̃AhX
	MOVWF	FSR
	MOVFW	INDF			;YoCg̒lǂݏo
	;
	ANDWF	tmp1, F			;YrbgNA
	;
	MOVFW	arg1
	IORLW	0
	BNZ		j4
	MOVFW	tmp1
	MOVWF	INDF			;ROMR[hobt@֏߂("0")
	RETURN

j4:
	MOVFW	tmp1
	IORWF	tmp2, W			;rbgp^[ORƂ("1")
	MOVWF	INDF			;ROMR[hobt@֏߂("1")
	RETURN


;*************************************************
; ROMR[hEobt@ NA
;*************************************************
OWClearRom:
	BANKSEL	tmp0
	MOVLW	8
	MOVWF	tmp0			;[v
	;
	BANKISEL	RomCode
	MOVLW	RomCode			;ROMR[hAhX
	MOVWF	FSR
lp5:
	CLRF	INDF			;f[^NA
	INCF	FSR, F			;̃AhX
	DECFSZ	tmp0, F
	GOTO	lp5
	RETURN


;*************************************************
; 1Xbgǂݏo 060906
;   OUT W:ǂݏof[^(0/1)
;*************************************************
OWRead1Slot:
	DQ	0				;DQ="L"
	WAIT5us	5			;wait 5us
	DQ	1				;DQ="H"(Hi-Z)
	WAIT5us	5			;wait 5us
	;
	BANKSEL	PORTC
	BTFSC	PORTC,	bitDQ
	GOTO	rs1
rs0:					;DQ="L"
	WAIT5us	50			;wait 50us
	RETLW	0
	;
rs1:					;DQ="H"
	WAIT5us	50			;wait 50us
	RETLW	1


;*************************************************
; 1Xbg
;    IN W:ރf[^(0/1)
;*************************************************
OWWrite1Slot:
	BANKSEL	tmp1
	MOVWF	tmp1
	;
	DQ	0				;DQ="L"
	WAIT5us	5			;wait 5us
	;
	RRF		tmp1, F		;b0
	BC		ws1
ws0:					;write "0" slot
	WAIT5us	60
	DQ	1				;DQ="H"(Hi-Z)
	NOP					;wait 2us
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	;
	RETURN
	;
ws1:					;write "1" slot
	DQ	1				;DQ="H"(Hi-Z)
	GOTO ws0


	END
