;
; }CR1 2 3C^[tF[Xp
;	copyright(c) T.Nakao 2007
;
; SPI \tgEFA쓮}X^^X[uEhCo
;

	LIST	 p=16f877a
	INCLUDE <p16F877a.inc>
	INCLUDE <..\\Common\\ComDef.inc>
	INCLUDE <..\\common\\Delay.inc>

	radix	dec

	GLOBAL	SPIMsInit, SPIMsCom
	GLOBAL	SPISlInit, SPISlCom
	GLOBAL	SPITxData, SPIRxData

bitSCK	EQU	3 		;RC3
bitSDI	EQU	4 		;RC4
bitSDO	EQU	5 		;RC5

;spiflag
SCKUp	EQU	0		;SCKオGbWo
SCKDown	EQU	1		;SCKGbWo
BefSCK	EQU	2		;OTCNSCK̏
Comm	EQU	3		;ʐM

	UDATA

SPITxData	RES	1	;Mf[^
SPIRxData	RES	1	;Mf[^
spiflag		RES	1	;tO(rbgϐ)

lpcnt	RES	1

	CODE

;****************************************
; SPI}X^(\tgEFA)
;****************************************
SPIMsInit:
	BANKSEL	TRISC
	BSF		TRISC, bitSDI		;input
	BCF		TRISC, bitSCK		;output
	BCF		TRISC, bitSDO		;output

	BANKSEL	PORTC
	BCF		PORTC, bitSCK
	BCF		PORTC, bitSDO

	RETURN


;****************************************
; SPI}X^M(\tgEFA)
;  IN:  SPITxData }X^Mf[^
;  OUT: SPIRxData }X^Mf[^
;****************************************
SPIMsCom:
	BANKSEL	lpcnt
	LDLF	8, lpcnt			;[vJE^

Loop:
	RLF		SPITxData, F		;CY=MSB̒l
	BC		out_h
	;
	; out_l
	BANKSEL	PORTC
	BCF		PORTC, bitSDO		;SDO="L"
	GOTO	nx1

out_h:
	BANKSEL	PORTC
	BSF		PORTC, bitSDO		;SDO="H"
nx1:
	;SCKo
	BSF		PORTC, bitSCK		;SCK="H"
	CALL	Delay
	BANKSEL	PORTC
	BCF		PORTC, bitSCK		;SCK="L"

	;SDI
	BTFSC	PORTC, bitSDI
	GOTO	in_h
	;
	;in_l
	CLRC						;CY="L"
	GOTO	nx2

in_h:
	SETC						;CY="H"
nx2:
	BANKSEL	SPIRxData
	RLF		SPIRxData, F		;1rbgۑ
	CALL	Delay

	DECFSZ	lpcnt
	GOTO	Loop

	RETURN

Delay:
	WAIT5us	30					;30us
	RETURN


;****************************************
; SPIX[u(\tgEFA)
;****************************************
SPISlInit:
	BANKSEL	TRISC
	BSF		TRISC, bitSDI		;input
	BSF		TRISC, bitSCK		;input
	BCF		TRISC, bitSDO		;output

	BANKSEL	PORTC
	BCF		PORTC, bitSDO

	BANKSEL	spiflag
	CLRF	spiflag				;0

	RETURN


;****************************************
; SPIX[uM(\tgEFA)
;  IN:  SPITxData
;  OUT: SPIRxData
;  RET: 0:false/1:true(ʐM)
;****************************************
SPISlCom:
	BANKSEL	lpcnt
	LDLF	8, lpcnt			;[vJE^
Loop2:
	CALL	SCKEdge
	BANKSEL	spiflag
	BTFSC	spiflag, SCKUp
	GOTO	sck_rise			;オGbWo
	;
	BTFSC	spiflag, SCKDown
	GOTO	sck_fall			;GbWo
	;
	;ωȂ
	BTFSS	spiflag, Comm
	RETLW	0					;ʐMłȂƂfalseňUI
	;
	;ʐM
	GOTO	Loop2
	;
	;----------------------------
	;SCLGbWo
	;----------------------------
sck_fall:
	BCF		spiflag, SCKDown

	;SDI
	BANKSEL	PORTC
	BTFSC	PORTC, bitSDI
	GOTO	in_h2
	;
	;in_l
	CLRC						;CY="L"
	GOTO	nx3

in_h2:
	SETC						;CY="H"
nx3:
	BANKSEL	SPIRxData
	RLF		SPIRxData, F		;1rbgۑ

	DECFSZ	lpcnt
	GOTO	Loop2

	BCF		spiflag, Comm		;"ʐM"
	RETLW	1					;true

	;----------------------------
	;SCLオGbWo
	;----------------------------
sck_rise:
	BCF		spiflag, SCKUp
	BSF		spiflag, Comm		;"ʐM"ɐݒ
	RLF		SPITxData, F		;CY=MSB̒l
	BC		out_h2
	;
	; out_l
	BANKSEL	PORTC
	BCF		PORTC, bitSDO		;SDO="L"
	GOTO	Loop2

out_h2:
	BANKSEL	PORTC
	BSF		PORTC, bitSDO		;SDO="H"
	GOTO	Loop2


;****************************************
; SCK̗オAGbW`FbN
;  OUT: spiflag.SCKUp
;  OUT: spiflag.SCKDown
;****************************************
SCKEdge:
	BANKSEL	PORTC
	BTFSC	PORTC, bitSCK
	GOTO	now_hi			;high
	;
	; now_low
	BANKSEL	spiflag
	BTFSS	spiflag, BefSCK
	RETURN					;bef low
	;
	; bef high(GbWo)
	BCF		spiflag, BefSCK
	BSF		spiflag, SCKDown
	RETURN

now_hi:
	BANKSEL	spiflag
	BTFSC	spiflag, BefSCK
	RETURN					;bef high
	;
	; bef low(オGbWo)
	BSF		spiflag, BefSCK
	BSF		spiflag, SCKUp
	RETURN

	END
