//
// }CR1 2 3C^[tF[Xp 15
//	copyright(c) T.Nakao 2007
//
// LED\ vO(SPI)
//	PIC16F876
//

#case	// 啶ʂ

#include "main152.h"
#include <string.h>
#include <ctype.h>

#include "..\Common\def877a.h"		// 877p}N`(p)
#include "..\Common\reg877a.h"		// 877pWX^`(p)
#include "..\Common\SPIHMS.c"		// n[hEFAE}X^/X[uEhCo

/*
J
LED     RC2
1(LSB)  RC1
2       RC0
3       RA3
4       RA2
5       RA1
6(MSB)  RA0

[(7ZOgLED̃ZOg)
A  RB0
B  RB1
C  RB2
D  RB3
E  RB4
F  RB5
G  RB6
DP RB7
*/

// vg^Cv錾
void InitApp(void);
void UpdateLED(void);
void ColPow(BYTE dgt);
void CommandProc(BYTE cmd);
void CmdA(BYTE cpara);
void CmdB(BYTE cpara);
void CmdC(BYTE cpara);
void CmdD(BYTE cpara);
void CmdE(BYTE cpara);
void CmdF(BYTE cpara);

// ZOgf[^(PORTBo͒l)
                    //   76543210
BYTE SegPat[16] = { //   PGFEDCBA
	0x3F,			// 0 00111111
	0x06,			// 1 00000110
	0x5B,			// 2 01011011
	0x4F,			// 3 01001111
	0x66,			// 4 01100110
	0x6D,			// 5 01101101
	0x7D,			// 6 01111101
	0x07,			// 7 00000111
	0x7F,			// 8 01111111
	0x6F,			// 9 01101111
	0x77,			// A 01110111
	0x7C,			// b 01111100
	0x39,			// C 00111001
	0x5E,			// d 01011110
	0x79,			// E 01111001
	0x71			// F 01110001
};


// e̕\f[^(l\LED)
//   [0-5]:l\
//     b7:    \/uN
//     b4:    _ON
//     b3-b0: lf[^(0`F)
//   [6]:LED
//     erbgLEDɑΉ
BYTE DigDat[7];


bool DigBlk = false;		// l\LEDuN
bool DigSts = false;		// l\LED ON/OFF

bool DigDsp = true;			// l\LED\
bool LedDsp = true;			// LED\
bool LedSts = false;		// LED̂ON/OFF
bool LedBlk = false;		// LEDuN

BYTE DigPtr = 0;			// \|C^(0`6)
BYTE CurPtr = 5;			// Jg|C^

BYTE LedBlPat = 0;			// eLED̃uNL
BYTE LedPat = 0;			// uŇLED̏o͏

BYTE DelayCount = 1;
BYTE Phase = 0;

BYTE BlkTmr1;
BYTE BlkTmr2;

#define GTIMER 150
#define OFF_TIME 1
#define ON_TIME  10
//#define GTIMER 65000
//#define OFF_TIME 5
//#define ON_TIME  10

#define BLKTMR1 50			// l\_Ŏ
#define BLKTMR2 20			// LED_Ŏ

#define MyI2CAdrs 3			// I2CX[uAhX


//*****************************************
// C
//*****************************************
void main() {
	int i = 0, dat;

	InitApp();					// ^C}ޏ
	SPISlInit();				// SPIX[u

	LedBlPat = 0x00;			// LED̃uNp^[

	// \f[^(uN)
	for(i = 0; i < 6; i++) {
		DigDat[i] = 0x80;
	}
	DigDat[6] = 0x00;

	// C[v
	while(1) {
		UpdateLED();					// \XV
		if(SPISlCom(&dat)) {			//X[uM
			// MĂƂ
			CommandProc(dat);			// R}h,s
		}
	}
}


//*****************************************
// 
//*****************************************
void InitApp(void) {

	TRISA &= 0xF0;				// RA0-RA3 output
	TRISB = 0x00;				// output
	TRISC &= 0xF8;				// RC0-RC2 output

	PORTB = 0x00;
	PORTC = 0x00;
	PORTA = 0x00;

	ADCON1 = 0x06;				// ADC All digital

	// CCP1&TIMER1 RyAE[h

	// CCP1 RyA[h INT/reset TMR1
	BitSet(CCP1CON, 3);			// CCP1M3-CCP1M0
	BitClr(CCP1CON, 2);			//   = (1011)
	BitSet(CCP1CON, 1);			//
	BitSet(CCP1CON, 0);			//

	// TIMER1
	BitSet(T1CON, T1CKPS1);		// T1CKPS1-0 = (11)
	BitSet(T1CON, T1CKPS0);		//   vXP[ 1/8
	BitClr(T1CON, TMR1CS);		// Fosc/4
	CCPR1L = GTIMER;
	CCPR1H = GTIMER >> 8;
	/*
		f = 20MHz/4 * 1/8 = 625KHz
		t = 1/f = 1.6us
		T = 1.6us * CCPR1(150) = 240us
	*/

	// ^C}X^[g
	TMR1L = 0;
	TMR1H = 0;
	CLR_SSPIF;
	BitSet(T1CON, TMR1ON);		// TIMER1 ON

	// uN\tg^C}
	BlkTmr1 = BLKTMR1;
	BlkTmr2 = BLKTMR2;
}


//*****************************************
// LED_Ci~bNhCu
// ̊֐̓C[vɑgݍ
//   061227 }CiX\ǉ
//*****************************************
void UpdateLED(void) {
	BYTE pat, val, dat;

	if(!TST_CCP1IF) {
		return;			// ^C}^CAbvĂȂƂ͑^[
	}
	CLR_CCP1IF;

	// ȍ~240usŎs鏈

	DelayCount--;							// \tgEFAEfBCXV
	if(DelayCount > 0) {
		return;								// ^CAbvĂȂƂ͑^[
	}

	switch(Phase) {
		// lLED1`6
		case 0:
			ColPow(7);						// SOFF
			Phase++;
			DelayCount = OFF_TIME;			// OFF
			break;
		case 1:
			dat = DigDat[DigPtr];			// f[^擾
			val = dat & 0x0F;				// \鐔l
			if(dat & 0x20) {				//
				// }CiX\
				pat = 0x40;
			} else {
				pat = SegPat[val];			// lɉp^[o
				if(dat & 0x10) {
					// _\
					pat |= 0x80;				// b7(DP) ON
				}
			}
			PORTB = pat;					// ZOgo

			if((dat & 0x80) == 0) {
				// ݂͕̌\
				if(DigBlk) {
					// uN̂Ƃ
					if(DigSts && DigDsp) {
						// ON^C~O&&l\ON
						ColPow(DigPtr);				// \ON
					}
					BlkTmr1--;
					if(BlkTmr1 == 0) {
						DigSts = !DigSts;			// Ԕ]
						BlkTmr1 = BLKTMR1;
					}
				} else if(DigDsp) {
					// ʏ\&&l\ON
					ColPow(DigPtr);					// \ON
				}
			}
			DigPtr++;
			if(DigPtr == 6) {
				Phase = 2;
			} else {
				Phase = 0;
			}
			DelayCount = ON_TIME;			// ON
			break;

		// LED
		case 2:
			ColPow(7);						// SOFF
			Phase++;
			DelayCount = OFF_TIME;			// OFF
			break;
		case 3:
			if(LedDsp) {
				// LED\ON
				pat = DigDat[DigPtr];		// m[}̓_p^[
				if(LedBlk) {
					// uN
					BlkTmr2--;
					if(BlkTmr2 == 0) {
						// LEDuÑ^C~O
						if(LedSts) {
							LedPat = pat;
						} else {
							// uNΏۂ̃rbgOFF
							// uNrbg"0"
							LedPat = pat & (~LedBlPat);
						}
						LedSts = !LedSts;			// Ԕ]
						BlkTmr2 = BLKTMR2;
					}
					PORTB = LedPat;
				} else {
					// ʏ_
					PORTB = pat;
				}
				ColPow(6);						// J6(LED) ON
			}
			Phase = 0;
			DigPtr = 0;
			DelayCount = ON_TIME;				// ON
			break;
	}
}


//*****************************************
// w̃Jij_
//*****************************************
void ColPow(BYTE dgt) {
	switch(dgt) {
		case 0:
			PC.B2 = 0;
			PC.B1 = 1;		// RC1(1) ON
			break;
		case 1:
			PC.B1 = 0;
			PC.B0 = 1;		// RC0(2) ON
			break;
		case 2:
			PC.B0 = 0;
			PA.B3 = 1;		// RA3(3) ON
			break;
		case 3:
			PA.B3 = 0;
			PA.B2 = 1;		// RA2(4) ON
			break;
		case 4:
			PA.B2 = 0;
			PA.B1 = 1;		// RA1(5) ON
			break;
		case 5:
			PA.B1 = 0;
			PA.B0 = 1;		// RA0(6) ON
			break;
		case 6:
			PA.B0 = 0;
			PC.B2 = 1;		// RC2(LED) ON
			break;
		default:			// ׂĂ̌OFF
			PC.B2 = 0;
			PC.B1 = 0;
			PC.B0 = 0;
			PA.B3 = 0;
			PA.B2 = 0;
			PA.B1 = 0;
			PA.B0 = 0;
			break;
	}
}


//*****************************************
// R}h
//*****************************************
void CommandProc(BYTE cmd) {
	BYTE cmdp, para;

	if((cmd & 0xC0) == 0) {
		// (A)f[^ݒR}h
		CmdA(cmd & 0x3F);			// R}h
	} else {
		cmdp = cmd & 0xE0;			// R}h(3rbg)
		para = cmd & 0x1F;			// p[^(5rbg)
		switch(cmdp) {
			case 0x40:				// (B)Jg|C^ݒR}h
				CmdB(para);			// R}h
				break;
			case 0x60:				// (C)_ʒuݒR}h
				CmdC(para);			// R}h
				break;
			case 0x80:				// (D)f[^NAER}h
				CmdD(para);			// R}h
				break;
			case 0xA0:				// (E)\ؑփR}h
				CmdE(para);			// R}h
				break;
			case 0xC0:				// (F)LEDݒR}h
				CmdF(para);			// R}h
				break;
		}
	}
}

//*****************************************
// (A)f[^ݒR}h
//   061227 }CiX\ǉ
//*****************************************
void CmdA(BYTE cpara) {
	BYTE dig;

	if((cpara & 0x30) == 0x30) {
		// f[^NA
		DigDat[CurPtr] = 0x80;				// OFF="1"(uN)
		return;
	}

	if((cpara & 0x30) == 0x20) {			// }CiX\
		DigDat[CurPtr] = 0x20;				// MN="1"(}CiX)
		if(CurPtr > 0) {
			CurPtr--;						// Jg|C^Eړ
		}
		return;
	}

	dig = DigDat[CurPtr] & 0xF0;			// Jg\f[^̉4rbgNA
	dig &= 0x5F;							// OFF,MN ="0"(\,}CiX)
	DigDat[CurPtr] = dig | (cpara & 0x0F);

	switch(cpara & 0x30) {
		case 0x00:					// Jg|C^Eړ
			if(CurPtr > 0) {
				CurPtr--;
			}
			break;
		case 0x10:					// Jg|C^ړ
			if(CurPtr < 5) {
				CurPtr++;
			}
			break;
		default:
			break;
	}
}

//*****************************************
// (B)Jg|C^ݒR}h
//*****************************************
void CmdB(BYTE cpara) {
	if(cpara < 6) {
		// 0`5
		CurPtr = 5 - cpara;
	}
}

//*****************************************
// (C)_ʒuݒR}h
//*****************************************
void CmdC(BYTE cpara) {
	BYTE i, p;

	p = cpara & 0x07;				// 3rbg
	if(p > 5) {
		return;
	}

	if(cpara & 0x10) {
		// EXr[h
		// USDPOFF
		for(i = 0; i < 6; i++) {
			DigDat[i] &= 0xEF;			// DP="0"
		}
	}


	if(cpara & 0x08) {
		// _ON
		DigDat[5-p] |= 0x10;			// DP="1"
	} else {
		DigDat[5-p] &= 0xEF;			// DP="0"
	}
}

//*****************************************
// (D)f[^NAER}h
//*****************************************
void CmdD(BYTE cpara) {
	BYTE i;

	switch(cpara) {
		case 0:					// ׂăuN(LED܂܂)
			for(i = 0; i < 6; i++) {
				DigDat[i] = 0x80;
			}
			break;
		case 1:					// ŉʂ̂"0",uN
			for(i = 1; i < 6; i++) {
				DigDat[i] = 0x80;
			}
			DigDat[0] = 0x00;	// "0"

			break;
		case 2:					// S"0"
			for(i = 0; i < 6; i++) {
				DigDat[i] = 0x00;
			}
			break;
		case 3:					// LEDuN
			for(i = 0; i < 6; i++) {
				DigDat[i] = 0x80;
			}
			DigDat[6] = 0x00;	// LEDSOFF
			LedBlPat = 0x00;	// LED̃uNp^[
			break;
	}
}

//*****************************************
// (E)\ؑփR}h
//*****************************************
void CmdE(BYTE cpara) {
	// l\
	if(cpara & 1) {
		// DSP1==1 ,_\
		DigDsp = true;
	} else {
		//
		DigDsp = false;
	}

	// LED\
	if(cpara & 2) {
		// DSP2==1 LED\
		LedDsp = true;
	} else {
		//
		LedDsp = false;
	}

	// l_
	if(cpara & 4) {
		// BLK1==1 ,__
		DigBlk = true;
		DigSts = true;
		BlkTmr1 = BLKTMR1;			// _Ń^C}
	} else {
		//
		DigBlk = false;
	}
}

//*****************************************
// (F)LEDݒR}h
//*****************************************
void CmdF(BYTE cpara) {
	BYTE led;
	led = cpara & 0x07;				// 0`7
	led = 1 << led;

	if(cpara & 0x10) {
		// BLK==1 uN
		LedBlPat |= led;				// BLn="1"
		LedSts = true;
		BlkTmr2 = BLKTMR2;				// _Ń^C}
	} else {
		LedBlPat &= ~led;				// BLn="0"
	}

	if(LedBlPat == 0) {
		// uNȂ
		LedBlk = false;
	} else {
		// uN
		LedBlk = true;
		BlkTmr2 = 1;				// ɓ_ŏɓ邽
	}

	if(cpara & 0x08) {
		// ON==1
		DigDat[6] |= led;			// LDn="1"
	} else {
		DigDat[6] &= ~led;			// LDn="0"
	}
}
