//
// }CR1 2 3C^[tF[Xp
//	copyright(c) T.Nakao 2007
//
//	I2Cn[hEFA}X^EhCo
//

#define WAIT_SSPIF while(!TST_SSPIF){}				   // SSPIFZbg҂
#define WAIT_BFCLR while(BitTest(SSPSTAT, BF)){}	// BFNA܂ő҂

//****************************************
// I2C(MSSPgp)
//****************************************
void I2CMsInit(void) {
	BitSet(SSPCON, SSPM3);		// SSPM3-0:1000
	BitClr(SSPCON, SSPM2);
	BitClr(SSPCON, SSPM1);
	BitClr(SSPCON, SSPM0);

//	BitClr(SSPSTAT, SMP);		// X[[g400KHz
	BitSet(SSPSTAT, SMP);		// X[[g100KHz
	BitClr(SSPSTAT, CKE);

//	SSPADD = 0x19				// {[[g400KHz
	SSPADD = 0x3F;				// {[[g100KHz

	BitSet(SSPCON, SSPEN);		// MSSP enable(ŌɎs邱)

	BitClr(SSPCON, WCOL);
	BitClr(SSPCON, SSPOV);
}

//****************************************
// I2CX^[gRfBV
//   IN  opt 0:NORM/1:REPEAT
//****************************************
void I2CStart(BYTE opt) {

	if(opt != 0) {
		// Repeat start condition
		BitSet(SSPCON2, RSEN);
	} else {
		// Normal start condition
		BitSet(SSPCON2, SEN);
	}

	WAIT_SSPIF;					// X^[gRfBV҂
	CLR_SSPIF;
}


//****************************************
// I2CXgbvRfBV
//****************************************
void I2CStop(void) {
	BitSet(SSPCON2, PEN);
	WAIT_SSPIF;					// XgbvRfBV҂
	CLR_SSPIF;

}


//****************************************
// I2C 1oCgf[^,ACKo(MSSP)
//   IN  ack: ACK(1:NOACK/0:ACK)
//   RET ̓f[^
//****************************************
BYTE I2CRead(BYTE ack) {
	BYTE dat;

	if(ack != 0) {
		// NOACK
		BitSet(SSPCON2, ACKDT);			// ACK=1
	} else {
		// ACK
		BitClr(SSPCON2, ACKDT);			// ACK=0
	}

	BitSet(SSPCON2, RCEN);				// M
	WAIT_SSPIF;							// M҂

	dat = SSPBUF;						// Mf[^o
	CLR_SSPIF;

	BitSet(SSPCON2, ACKEN);				// ACKM
	WAIT_SSPIF;							// ACKM҂

	CLR_SSPIF;
	return dat;
}

//****************************************
// I2C 1oCgf[^o,ACK(MSSP)
//   IN   dat: o̓f[^
//   RET  0:ACK/1:NOACK
//****************************************
BYTE I2CWrite(BYTE dat) {
	WAIT_BFCLR;					// BFNA܂ő҂

	SSPBUF = dat;				// MJn
	CLR_SSPIF;

	WAIT_SSPIF;					// M҂

	//SSPCON2.ACKSTATACKԂĂ

	if(BitTest(SSPCON2, ACKSTAT)) {
		CLR_SSPIF;
		return 1;				// NOACK
	} else {
		CLR_SSPIF;
		return 0;				// ACK
	}
}


//****************************************
// I2Cf[^M
//   IN  adrs:X[uAhX
//        dat: Mf[^
//****************************************
void I2C_TxData(adrs, dat) {
	adrs <<= 1;					// I2CX[uAhX l R/W = 0

	I2CStart(0);				// X^[gRfBV
	I2CWrite(adrs);				// CB(W)M
	I2CWrite(dat);				// f[^M
	I2CStop();					// XgbvRfBV
}


//****************************************
// I2Cf[^M
//	IN  adrs:I2CX[uAhX
//	RET Mf[^
//****************************************
BYTE I2C_RxData(adrs) {
	BYTE dat;

	adrs <<= 1;					// I2CX[uAhX l R/W = 0
	adrs |= 1;					// R/W = 1

	I2CStart(0);				// X^[gRfBV
	I2CWrite(adrs);				// CB(R)M

	dat = I2CRead(1);			// Mf[^(NOACK)
	I2CStop();					// XgbvRfBV

	return dat;
}
