//
// }CR1 2 3C^[tF[Xp
//	copyright(c) T.Nakao 2007
//
//	1-Wire\tgEFA}X^EhCo
//

#define bitDQ	3		// RC3
#define bitSPU	4		// RC4

// vg^Cv
void SetDQ(BYTE dat);
void OWInit(void);
BYTE OWBusReset(void);
void OWWriteByte(BYTE txdat);
BYTE OWReadByte(void);
BYTE OWCrc(BYTE *rcode, BYTE cnt);
BYTE OWRomSearch(void);
BYTE OWReSearch(void);
void out1(void);
void out0(void);
BYTE OWGetRomBit(BYTE bnum);
void OWSetRomBit(bnum, dat);
void OWClearRom(void);
BYTE OWRead1Slot(void);
void OWWrite1Slot(BYTE txdat);


BYTE LastB;
BYTE ZeroB;
BYTE n;

BYTE RomCode[8];		// ROMR[hobt@
BYTE OWDviceCnt;		// ofoCX


//*************************************************
// DQ output "L" or "H"(Hi-Z pullup)
//*************************************************
void SetDQ(BYTE dat) {
	if(dat) {
		BitSet(TRISC, bitDQ);	// input(Hi-Z)
		//
	} else {					// output L
		BitClr(PORTC, bitDQ);	// reset DQ
		BitClr(TRISC, bitDQ);	// output
	}
}


//*************************************************
//  1-Wire 
//*************************************************
void OWInit(void) {
	BitClr(PORTC, bitSPU);
	BitSet(TRISC, bitDQ);		// input(Hi-Z:H)
	BitClr(TRISC, bitSPU);		// output
}


//*************************************************
//  oXEZbgs(v[XEpXo)
//    RET  true:v[XEpXo
//*************************************************
BYTE OWBusReset(void) {
	SetDQ(0);						// DQ="L"
	delay_us(500);					// wait 500us
	SetDQ(1);						// DQ="H"(Hi-Z)
	delay_us(70);					// wait 70us
	if(BitTst(PORTC, bitDQ)) {
		// "H"
		delay_us(430);				// wait 430us
		return false;				// 񌟏o
	} else {
		// "L"
		delay_us(430);				// wait 430us
		return true;				// oXZbgo
	}
}


//*************************************************
//  1-Wire 1oCgo
//    IN txdat:o̓f[^
//*************************************************
void OWWriteByte(BYTE txdat) {
	BYTE i;

	for(i = 0; i < 8; i++) {
		SetDQ(0);				// DQ="L"
		delay_us(5);			// wait 5us
		if(txdat & 1) {
			// 1
			SetDQ(1);			// DQ="H"(Hi-Z)
		}
		delay_us(60);			// wait 60us
		SetDQ(1);				// DQ="H"(Hi-Z)
		delay_us(2);			// wait 2us
		txdat >>= 1;			// ̃rbg
	}
}


//*************************************************
//  1-Wire 1oCg
//    RET: ̓f[^
//*************************************************
BYTE OWReadByte(void) {
	BYTE i, dat = 0;

	for(i = 0; i < 8; i++) {
		SetDQ(0);				// DQ="L"
		delay_us(5);			// wait 5us
		SetDQ(1);				// DQ="H"(Hi-Z)
		delay_us(5);			// wait 5us
		dat >>= 1;
		if(BitTst(PORTC, bitDQ)) {
			// 1
			dat |= 0x80;
		}
		delay_us(50);			// wait 50us
	}
	return dat;
}


//*************************************************
//  1-Wire CRCvZ
//    vZΏۂ̗̈̐擪AhXn悤ɕύX
//
//    IN
//      cnt:   vZΏۂ̃oCg(8or9)
//      rcode: vZΏۂ̗̈̐擪AhX
//    RET
//      vZ(0̂Ƃ)
//*************************************************
BYTE OWCrc(BYTE *rcode, BYTE cnt) {
	BYTE dat, A, crcsr;
	int i, j;

	crcsr = 0;
	A = 0;

	for(i = 0; i < 8; i++) {		// 8oCgJԂ
		dat = rcode[i];				// Ώۂ1oCgo
		for(j = 0; j < 8; j++) {	// 8rbgJԂ
			A = (dat ^ crcsr) & 1;	// LSB̂ݎgp
			if(A == 1) {
				crcsr ^= 0x18;		// 4,5Xe[ŴXOR
			}
			crcsr >>= 1;
			if(A == 1) {
				crcsr |= 0x80;		// AMSBɐݒ
			}
			dat >>= 1;				// ΏۂVtg
		}
	}
	return crcsr;
}


//*************************************************
// ROMR[h
//   RET
//    0:s / 1:(cȂ) / 2:(c)
//*************************************************
BYTE OWRomSearch(void) {
	OWDviceCnt = 0;			// ofoCX
	LastB = 0;
	OWClearRom();			// ROMR[hobt@ NA
	return OWReSearch();
}


//*************************************************
// ROMR[h2
//  ROMp(2߈ȍ~̌)
//   RET
//    0:s / 1:(cȂ) / 2:(c)
//*************************************************
BYTE OWReSearch(void) {
	n = 1;
	ZeroB = 0;

	//  oXEZbg
	if(!OWBusReset()) {
		return 0;			// v[XpX񌟏o
	}

	OWWriteByte(0xF0);		// SEARCH ROM command
	do {
		if(OWRead1Slot()) {		// bnǂݍ
			//  bn==1
			if(!OWRead1Slot()) {			// /bnǂݍ
				// **** "1"pX **** (bn,/bn)==(1,0)
				out1();
			} else {
				// **** G[ **** (bn,/bn)==(1,1)
				return 0;
			}
		} else {
			//  bn==0
			if(OWRead1Slot()) {			// /bnǂݍ
				// **** "0"pX **** (bn,/bn)==(0,1)
				out0();						// "0"pX
			} else {
				// **** sv_ **** (bn,/bn)==(0,0)
				if(n == LastB) {
					out1();					// "1"pX
				} else if(n < LastB) {
					//  OɌoꂽfoCXROMR[hnrbgƓl
					if(OWGetRomBit(n)) {
						out1();				// "1"pX
					} else {
						ZeroB = n;
						out0();				// "0"pX
					}
				} else {
					ZeroB = n;
					out0();					// "0"pX
				}
			}
		}
		n++;								// ̃rbg
	} while(n <= 64);

	//  64rbgROMR[ho

	LastB = ZeroB;
	OWDviceCnt++;		// ofoCX

	if(LastB == 0) {
		return 1;		// I (cȂ)
	}
	return 2;			// I (c肠)
}


//*************************************************
//  "1"XbgM
//*************************************************
void out1(void) {
	OWWrite1Slot(1);		// "1"Xbgo
	OWSetRomBit(n, 1);
}


//*************************************************
//  "0"XbgM
//*************************************************
void out0(void) {
	OWWrite1Slot(0);		// "0"Xbgo
	OWSetRomBit(n, 0);
}


//*************************************************
// ROMR[hEobt@ _rbgl擾
//   IN  bnum:rbgԍ(1`64)
//   RET rbgl(0/1)
//*************************************************
BYTE OWGetRomBit(BYTE bnum) {
	BYTE by, bt;
	bnum--;
	by = bnum / 8;
	bt = bnum % 8;

	bt = 1 << bt;
	if(RomCode[by] & bt) {
		return 1;
	} else {
		return 0;
	}
}


//*************************************************
// ROMR[hEobt@ _rbglݒ
//   IN  bnum:rbgԍ(1`64)
//       dat:ݒl(0/1)
//*************************************************
void OWSetRomBit(bnum, dat) {
	BYTE by, bt;
	bnum--;
	by = bnum / 8;
	bt = bnum % 8;

	bt = 1 << bt;
	if(dat) {
		// set
		RomCode[by] |= bt;
	} else {
		// reset
		RomCode[by] &= ~bt;
	}
}


//*************************************************
// ROMR[hEobt@ NA
//*************************************************
void OWClearRom(void) {
	BYTE i;

	for(i = 0; i < 8; i++) {
		RomCode[i] = 0;
	}
}


//*************************************************
// 1Xbgǂݏo
//    RET ǂݏof[^(0/1)
//*************************************************
BYTE OWRead1Slot(void) {
	SetDQ(0);				// DQ="L"
	delay_us(5);			// wait 5us
	SetDQ(1);				// DQ="H"(Hi-Z)
	delay_us(5);			// wait 5us

	if(BitTst(PORTC, bitDQ)) {
		// DQ="H"
		delay_us(50);		// wait 50us
		return 1;
	} else {
		// DQ="L"
		delay_us(50);		// wait 50us
		return 0;
	}
}


//*************************************************
// 1Xbg
//    IN txdat:ރf[^(0/1)
//*************************************************
void OWWrite1Slot(BYTE txdat) {
	SetDQ(0);				// DQ="L"
	delay_us(5);			// wait 5us

	if(txdat) {
		// "1"
		SetDQ(1);			// DQ="H"(Hi-Z)
	}
	delay_us(60);			// wait 60us
	SetDQ(1);				// DQ="H"(Hi-Z)
	delay_us(2);			// wait 2us
}
