//
// }CR1 2 3C^[tF[Xp
//	copyright(c) T.Nakao 2007
//
//	SPI\tgEFA}X^^X[uEhCo
//

#define bitSCK	3 		// RC3
#define bitSDI	4 		// RC4
#define bitSDO	5 		// RC5

bool SCKUp;			// SCKオGbWo
bool SCKDown;		// SCKGbWo
bool BefSCK;		// OTCNSCK̏
bool Comm;			// ʐM

// vg^Cv錾
void Delay(void);
void SCKEdge(void);


//****************************************
// SPI}X^(\tgEFA)
//****************************************
void SPIMsInit(void) {
	BitSet(TRISC, bitSDI);		// input
	BitClr(TRISC, bitSCK);		// output
	BitClr(TRISC, bitSDO);		// output

	BitClr(PORTC, bitSCK);
	BitClr(PORTC, bitSDO);
}


//****************************************
// SPI}X^M(\tgEFA)
//  IN:  txdat }X^Mf[^
//  RET: }X^Mf[^
//****************************************
BYTE SPIMsCom(BYTE txdat) {
	BYTE i, rxdat = 0;

	for(i = 0; i < 8; i++) {
		if(txdat & 0x80) {				// MSBo
			// "1"
			BitSet(PORTC, bitSDO);		// SDO="H"
		} else {
			// "0"
			BitClr(PORTC, bitSDO);		// SDO="L"
		}
		txdat <<= 1;					// ̃rbg

		// SCKo
		BitSet(PORTC, bitSCK);			// SCK="H"
		Delay();
		BitClr(PORTC, bitSCK);			// SCK="L"
		Delay();

		rxdat <<= 1;
		// SDI
		if(BitTst(PORTC, bitSDI)) {
			// "1"
			rxdat |= 1;					// LSB="1"
		}
	}
	return rxdat;
}


//****************************************
// SPIX[u(\tgEFA)
//****************************************
void SPISlInit(void) {
	BitSet(TRISC, bitSDI);		// input
	BitSet(TRISC, bitSCK);		// input
	BitClr(TRISC, bitSDO);		// output

	BitClr(PORTC, bitSDO);

	SCKUp = false;				// SCKオGbWo
	SCKDown = false;			// SCKGbWo
	BefSCK = false;				// OTCNSCK̏
	Comm = false;				// ʐM
}


//****************************************
// SPIX[uM(\tgEFA)
//  IN:  SPITxData
//  OUT: SPIRxData
//  RET: 0:false/1:true(ʐM)
//****************************************
BYTE SPISlCom(BYTE *dat) {
	BYTE lpcnt = 0, txdat, rxdat = 0;

	txdat = *dat;							// Mf[^

	while(1) {
		SCKEdge();
		if(SCKUp) {
			// オGbWo
			SCKUp = false;
			Comm = true;					// "ʐM"ɐݒ
			if(txdat & 0x80) {				// MSBo
				// "1"
				BitSet(PORTC, bitSDO);		// SDO="H"
			} else {
				// "0"
				BitClr(PORTC, bitSDO);		// SDO="L"
			}
			txdat <<= 1;					// ̑Mrbg̏
		} else if(SCKDown) {
			// GbWo
			SCKDown = false;
			rxdat <<= 1;
			if(BitTst(PORTC, bitSDI)) {
				// "1"
				rxdat |= 1;					// LSB="1"
			}
			lpcnt++;
			if(lpcnt == 8) {
				Comm = false;				// "ʐM"
				*dat = rxdat;				// Mf[^ɓn
				return true;				// M
			}
		} else if(!Comm) {
			// ωȂ ʐMłȂƂ
				return false;
		}
	}
}

void Delay(void) {
	delay_us(30);					// 30us
}


//****************************************
// SCK̗オAGbW`FbN
//  OUT: SCKUp:   オGbWo
//       SCKDown: GbWo
//****************************************
void SCKEdge(void) {
	if(BitTst(PORTC, bitSCK)) {
		//  "H"
		if(BefSCK) {
			// O "H"
			return;			// SCKωȂ
		} else {
			// O "L"
			// SCK "L" "H" オGbWo
			BefSCK = 1;
			SCKUp = true;
			return;
		}
	} else {
		//  "L"
		if(BefSCK) {
			// O "H"
			// SCK "H" "L" GbWo
			BefSCK = 0;
			SCKDown = true;
			return;
		} else {
			// O "L"
			return;			// SCKωȂ
		}
	}
}
