//
// }CR1 2 3C^[tF[Xp
//	copyright(c) T.Nakao 2007
//
// }N` 16F877A CCS-Cp
//

#ifndef DEF877A_H
#define DEF877A_H

// for CCS-C bit width
typedef unsigned int32 DWORD;
typedef int1 bool;
typedef unsigned int16 WORD;

#define TST_INTF   (INTCON&(1<<INTF))		// INTFtO`FbN
#define TST_TMR0IF (INTCON&(1<<TMR0IF))		// TMR0IFtO`FbN
#define TST_RBIF   (INTCON&(1<<RBIF))		// RBIFtO`FbN
#define TST_PSPIF  (PIR1&(1<<PSPIF))		// PSPIFtO`FbN
#define TST_ADIF   (PIR1&(1<<ADIF))			// ADIFtO`FbN
#define TST_RCIF   (PIR1&(1<<RCIF))			// RCIFtO`FbN
#define TST_TXIF   (PIR1&(1<<TXIF))			// TXIFtO`FbN
#define TST_SSPIF  (PIR1&(1<<SSPIF))		// SSPIFtO`FbN
#define TST_TMR2IF (PIR1&(1<<TMR2IF))		// TMR2IFtO`FbN
#define TST_TMR1IF (PIR1&(1<<TMR1IF))		// TMR1IFtO`FbN
#define TST_EEIF   (PIR2&(1<<EEIF))			// EEIFtO`FbN
#define TST_CCP1IF (PIR1&(1<<CCP1IF))		// CCP1IFtO`FbN
#define TST_CCP2IF (PIR2&(1<<CCP2IF))		// CCP2IFtO`FbN

#define CLR_INTF   (INTCON&=~(1<<INTF))		// RB0(INTF)tONA
#define CLR_TMR0IF (INTCON&=~(1<<TMR0IF))		// TMR0IFtONA
#define CLR_RBIF   (INTCON&=~(1<<RBIF))		// RBIFtONA
#define CLR_PSPIF  (PIR1&=~(1<<PSPIF))		// PSPIFtONA
#define CLR_ADIF   (PIR1&=~(1<<ADIF))			// ADIFtONA
#define CLR_RCIF   (PIR1&=~(1<<RCIF))			// RCIFtONA
#define CLR_TXIF   (PIR1&=~(1<<TXIF))			// TXIFtONA
#define CLR_SSPIF  (PIR1&=~(1<<SSPIF))		// SSPIFtONA
#define CLR_TMR2IF (PIR1&=~(1<<TMR2IF))		// TMR2IFtONA
#define CLR_TMR1IF (PIR1&=~(1<<TMR1IF))		// TMR1IFtONA
#define CLR_EEIF   (PIR2&=~(1<<EEIF))			// EEIFtONA
#define CLR_CCP1IF (PIR1&=~(1<<CCP1IF))		// CCP1IFtONA
#define CLR_CCP2IF (PIR2&=~(1<<CCP2IF))		// CCP2IFtONA

#define EI_GLOBAL (INTCON|=(1<<GIE))		// GLOBAL
#define EI_PERIP  (INTCON|=(1<<PEIE))		// PERIP
#define EI_INT    (INTCON|=(1<<INTE))		// INT
#define EI_TMR0   (INTCON|=(1<<TMR0IE))		// TMR0
#define EI_RB     (INTCON|=(1<<RBIE))		// RB
#define EI_PSP    (PIE1|=(1<<PSPIE))		// PSP
#define EI_AD     (PIE1|=(1<<ADIE))			// AD
#define EI_RC     (PIE1|=(1<<RCIE))			// RC
#define EI_TX     (PIE1|=(1<<TXIE))			// TX
#define EI_SSP    (PIE1|=(1<<SSPIE))		// SSP
#define EI_TMR2   (PIE1|=(1<<TMR2IE))		// TMR2
#define EI_TMR1   (PIE1|=(1<<TMR1IE))	// TMR1
#define EI_EE     (PIE2|=(1<<EEIE))			// EE
#define EI_CCP1   (PIE1|=(1<<CCP1IE))		// CCP1
#define EI_CCP2   (PIE2|=(1<<CCP2IE))	// CCP2

#define EI_CM     (PIE1|=(1<<CMIE))			// Rp[^


#define DI_GLOBAL (INTCON&=~(1<<GIE))		// GLOBAL֎~
#define DI_PERIP  (INTCON&=~(1<<PEIE))	// PERIP֎~
#define DI_INT    ((INTCON&=~(1<<INTE))		// INT֎~
#define DI_TMR0   (INTCON&=~(1<<TMR0IE))	// TMR0֎~
#define DI_RB     (INTCON&=~(1<<RBIE))	// RB֎~
#define DI_PSP    (PIE1&=~(1<<PSPIE))		// PSP֎~
#define DI_AD     (PIE1&=~(1<<ADIE))		// AD֎~
#define DI_RC     (PIE1&=~(1<<RCIE))		// RC֎~
#define DI_TX     (PIE1&=~(1<<TXIE))		// TX֎~
#define DI_SSP    (PIE1&=~(1<<SSPIE))		// SSP֎~
#define DI_TMR2   (PIE1&=~(1<<TMR2IE))	// TMR2֎~
#define DI_TMR1   (PIE1&=~(1<<TMR1IE))	// TMR1֎~
#define DI_EE     (PIE2&=~(1<<EEIE)		// EE֎~
#define DI_CCP1   (PIE1&=~(1<<CCP1IE))	// CCP1֎~
#define DI_CCP2   (PIE2&=~(1<<CCP2IE))	// CCP2֎~

#define DI_CM     (PIE1&=~(1<<CMIE))		// Rp[^֎~

#define TST_EEWrite_NOT_DONE (EECON1&(1<<WR))	// EEPROM Write
#define ADC_START ADCON0|=(1<<GO)				// ADϊJn
#define TST_ADC_NOT_DONE (ADCON0&(1<<GO))		// ADϊ҂

#define RB_PULLUP_ON  OPTION_REG&=~(1<<NOT_RBPU)	// RBvAbvL
#define RB_PULLUP_OFF OPTION_REG|=(1<<NOT_RBPU)		// RBvAbv

#define BitTest(p, b) (p&(1<<b))
#define BitTst(p, b) (p&(1<<b))
#define BitSet(p, b) (p|=(1<<b))
#define BitClear(p, b) (p&=(~(1<<b)))
#define BitClr(p, b) (p&=(~(1<<b)))

#define TIMER1_ON T1CON|=(1<<TMR1ON)		// TIMER1 START
#define TIMER1_OFF T1CON&=~(1<<TMR1ON)		// TIMER1 STOP
#define TIMER2_ON T2CON|=(1<<TMR2ON)		// TIMER2 START
#define TIMER2_OFF T2CON&=~(1<<TMR2ON)		// TIMER2 STOP

#define true  1
#define false 0

#endif
