//
// }CR1 2 3C^[tF[Xp
//	copyright(c) T.Nakao 2007
//
// PIC16F877A WX^EAhXArbg`(CCS-Cp)
//

#ifndef REG877A_H
#define REG877A_H

// WX^EAhX

//----- Register Files------------------------------------------------------
#byte INDF    = 0x0000
#byte TMR0    = 0x0001
#byte PCL     = 0x0002
#byte STATUS  = 0x0003
#byte FSR     = 0x0004
#byte PORTA   = 0x0005
#byte PORTB   = 0x0006
#byte PORTC   = 0x0007
#byte PORTD   = 0x0008
#byte PORTE   = 0x0009
#byte PCLATH  = 0x000A
#byte INTCON  = 0x000B
#byte PIR1    = 0x000C
#byte PIR2    = 0x000D
#byte TMR1L   = 0x000E
#byte TMR1H   = 0x000F
#byte T1CON   = 0x0010
#byte TMR2    = 0x0011
#byte T2CON   = 0x0012
#byte SSPBUF  = 0x0013
#byte SSPCON  = 0x0014
#byte CCPR1L  = 0x0015
#byte CCPR1H  = 0x0016
#byte CCP1CON = 0x0017
#byte RCSTA   = 0x0018
#byte TXREG   = 0x0019
#byte RCREG   = 0x001A
#byte CCPR2L  = 0x001B
#byte CCPR2H  = 0x001C
#byte CCP2CON = 0x001D
#byte ADRESH  = 0x001E
#byte ADCON0  = 0x001F
#byte OPTION_REG = 0x0081
#byte TRISA   = 0x0085
#byte TRISB   = 0x0086
#byte TRISC   = 0x0087
#byte TRISD   = 0x0088
#byte TRISE   = 0x0089
#byte PIE1    = 0x008C
#byte PIE2    = 0x008D
#byte PCON    = 0x008E
#byte SSPCON2 = 0x0091
#byte PR2     = 0x0092
#byte SSPADD  = 0x0093
#byte SSPSTAT = 0x0094
#byte TXSTA   = 0x0098
#byte SPBRG   = 0x0099
#byte CMCON   = 0x009C
#byte CVRCON  = 0x009D
#byte ADRESL  = 0x009E
#byte ADCON1  = 0x009F
#byte EEDATA  = 0x010C
#byte EEADR   = 0x010D
#byte EEDATH  = 0x010E
#byte EEADRH  = 0x010F
#byte EECON1  = 0x018C
#byte EECON2  = 0x018D

// rbgEAhX
//----- STATUS Bits --------------------------------------------------------
enum T_STATUS {
IRP = 0x07, RP1 = 0x06, RP0 = 0x05, NOT_TO = 0x04, NOT_PD = 0x03,
 Z = 0x02, DC = 0x01, C = 0x00
};
//----- INTCON Bits --------------------------------------------------------
enum T_INTCON {
GIE = 0x07, PEIE = 0x06, TMR0IE = 0x05, INTE = 0x04, RBIE = 0x03,
 TMR0IF = 0x02, INTF = 0x01, RBIF = 0x00
};
//----- PIR1 Bits ----------------------------------------------------------
enum T_PIR1 {
PSPIF = 0x07, ADIF = 0x06, RCIF = 0x05, TXIF = 0x04, SSPIF = 0x03,
 CCP1IF = 0x02, TMR2IF = 0x01, TMR1IF = 0x00
};
//----- PIR2 Bits ----------------------------------------------------------
enum T_PIR2 {
CMIF=6, EEIF = 0x04, BCLIF = 0x03, CCP2IF = 0x00
};
//----- T1CON Bits ---------------------------------------------------------
enum T_T1CON {
T1CKPS1 = 0x05, T1CKPS0 = 0x04, T1OSCEN = 0x03, NOT_T1SYNC = 0x02,
 TMR1CS = 0x01, TMR1ON = 0x00
};
//----- T2CON Bits ---------------------------------------------------------
enum T_T2CON {
TOUTPS3 = 0x06, TOUTPS2 = 0x05, TOUTPS1 = 0x04, TOUTPS0 = 0x03,
 TMR2ON = 0x02, T2CKPS1 = 0x01, T2CKPS0 = 0x00
};
//----- SSPCON Bits --------------------------------------------------------
enum T_SSPCON {
WCOL = 0x07, SSPOV = 0x06, SSPEN = 0x05, CKP = 0x04, SSPM3 = 0x03,
 SSPM2 = 0x02, SSPM1 = 0x01, SSPM0 = 0x00
};
//----- CCP1CON Bits -------------------------------------------------------
enum T_CCP1CON {
CCP1X = 0x05, CCP1Y = 0x04, CCP1M3 = 0x03, CCP1M2 = 0x02, CCP1M1 = 0x01,
 CCP1M0 = 0x00
};
//----- RCSTA Bits ---------------------------------------------------------
enum T_RCSTA {
SPEN = 0x07, RX9 = 0x06, SREN = 0x05, CREN = 0x04, ADDEN = 0x03,
 FERR = 0x02, OERR = 0x01, RX9D = 0x00
};
//----- CCP2CON Bits -------------------------------------------------------
enum T_CCP2CON {
CCP2X = 0x05, CCP2Y = 0x04, CCP2M3 = 0x03, CCP2M2 = 0x02, CCP2M1 = 0x01,
 CCP2M0 = 0x00
};
//----- ADCON0 Bits --------------------------------------------------------
enum T_ADCON0 {
ADCS1 = 0x07, ADCS0 = 0x06, CHS2 = 0x05, CHS1 = 0x04, CHS0 = 0x03,
 GO = 0x02, CHS3 = 0x01, ADON = 0x00
};
//----- OPTION Bits --------------------------------------------------------
enum T_OPTION {
NOT_RBPU = 0x07, INTEDG = 0x06, T0CS = 0x05, T0SE = 0x04, PSA = 0x03,
 PS2 = 0x02, PS1 = 0x01, PS0 = 0x00
};
//----- TRISE Bits ---------------------------------------------------------
enum T_TRISE {
IBF = 0x07, OBF = 0x06, IBOV = 0x05, PSPMODE = 0x04, TRISE2 = 0x02,
 TRISE1 = 0x01, TRISE0 = 0x00
};
//----- PIE1 Bits ----------------------------------------------------------
enum T_PIE1 {
PSPIE = 0x07, ADIE = 0x06, RCIE = 0x05, TXIE = 0x04, SSPIE = 0x03,
 CCP1IE = 0x02, TMR2IE = 0x01, TMR1IE = 0x00
};
//----- PIE2 Bits ----------------------------------------------------------
enum T_PIE2 {
CMIE=6, EEIE = 0x04, BCLIE = 0x03,
CCP2IE = 0x00
};
//----- PCON Bits ----------------------------------------------------------
enum T_PCON {
NOT_POR = 0x01, NOT_BO = 0x00
};
//----- SSPCON2 Bits --------------------------------------------------------
enum T_SSPCON2 {
GCEN = 0x07, ACKSTAT = 0x06, ACKDT = 0x05, ACKEN = 0x04, RCEN = 0x03,
 PEN = 0x02, RSEN = 0x01 , SEN = 0x00
};
//----- TXSTA Bits ---------------------------------------------------------
enum T_TXSTA {
CSRC = 0x07, TX9 = 0x06, TXEN = 0x05, SYNC = 0x04, BRGH = 0x02,
 TRMT = 0x01, TX9D = 0x00
};
//----- ADCON1 Bits --------------------------------------------------------
enum T_ADCON1 {
ADFM = 0x07, PCFG3 = 0x03, PCFG2 = 0x02, PCFG1 = 0x01, PCFG0 = 0x00
};
//----- EECON1 Bits --------------------------------------------------------
enum T_EECON1 {
EEPGD = 0x07, WRERR = 0x03, WREN = 0x02, WR = 0x01, RD = 0x00
};
//----- CMCON Bits ---------------------------------------------------------
//enum T_CMCON {
//C2OUT= 0x07, C1OUT= 0x06, C2INV= 0x05, C1INV= 0x04, CIS= 0x03,
// CM2= 0x02, CM1= 0x01, CM0= 0x00
//};

//----- CVRCON Bits --------------------------------------------------------
enum T_CVRCON {
CVREN = 0x07, CVROE = 0x06, CVRR = 0x05, CVR3 = 0x03, CVR2 = 0x02,
 CVR1 = 0x01, CVR0 = 0x00
};

//----- SSPSTAT Bits  061128 -----------------------------------------------
enum T_SSPSTAT {
SMP = 0x07, CKE = 0x06, D_A = 0x05, P = 0x04, S = 0x03, R_W = 0x02,
 UA = 0x01, BF = 0x00
};

struct TAG_PORT {
 unsigned char B0:1;
 unsigned char B1:1;
 unsigned char B2:1;
 unsigned char B3:1;
 unsigned char B4:1;
 unsigned char B5:1;
 unsigned char B6:1;
 unsigned char B7:1;
};

struct TAG_PORT PA;
#byte PA = 5

struct TAG_PORT PB;
#byte PB = 6

struct TAG_PORT PC;
#byte PC = 7

struct TAG_PORT PD;
#byte PD = 8

struct TAG_PORT PE;
#byte PE = 9


#endif
